/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./wapi.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./functions/add-participant.js":
/*!**************************************!*\
  !*** ./functions/add-participant.js ***!
  \**************************************/
/*! exports provided: addParticipant */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addParticipant", function() { return addParticipant; });
/**
 * Adds participant to group
 * @param {string} groupId Chat id ('0000000000-00000000@g.us')
 * @param {string} participantId Participant id'000000000000@c.us'
 * @param {Function} done Optional callback
 */
async function addParticipant(groupId, participantId, done) {
  const chat = Store.Chat.get(groupId);
  const participant = Store.Contact.get(participantId);
  return window.Store.Participants.addParticipants(chat, [participant]).then(
    () => {
      done(true);
      return true;
    }
  );
}


/***/ }),

/***/ "./functions/are-all-messages-loaded.js":
/*!**********************************************!*\
  !*** ./functions/are-all-messages-loaded.js ***!
  \**********************************************/
/*! exports provided: areAllMessagesLoaded */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "areAllMessagesLoaded", function() { return areAllMessagesLoaded; });
/**
 * Checks if all messages are loaded
 * @param {string} id Chat id
 * @param {Function} done Optional callback
 */
function areAllMessagesLoaded(id, done) {
  const found = WAPI.getChat(id);
  if (!found.msgs.msgLoadState.noEarlierMsgs) {
    if (done) done(false);
    return false;
  }
  if (done) done(true);
  return true;
}


/***/ }),

/***/ "./functions/block-contact.js":
/*!************************************!*\
  !*** ./functions/block-contact.js ***!
  \************************************/
/*! exports provided: blockContact */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "blockContact", function() { return blockContact; });
/**
 * Blocks contact
 * @param {string} id Contact id (00000000@c.us)
 * @param {Function} done Optional callback
 */
function blockContact(id, done) {
  const contact = window.Store.Contact.get(id);
  if (contact !== undefined) {
    contact.setBlock(!0);
    done(true);
    return true;
  }
  done(false);
  return false;
}


/***/ }),

/***/ "./functions/clear-chat.js":
/*!*********************************!*\
  !*** ./functions/clear-chat.js ***!
  \*********************************/
/*! exports provided: clearChat */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "clearChat", function() { return clearChat; });
/**
 * Clears chat messages
 * @param {string} id Chat id
 */
async function clearChat(id) {
  return await Store.ChatUtil.sendClear(Store.Chat.get(id), true);
}


/***/ }),

/***/ "./functions/create-group.js":
/*!***********************************!*\
  !*** ./functions/create-group.js ***!
  \***********************************/
/*! exports provided: createGroup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "createGroup", function() { return createGroup; });
/**
 * Creates group
 * @param {string} name Group name
 * @param {string[]} contactsId Contacts ids
 */
async function createGroup(name, contactsId) {
  if (!Array.isArray(contactsId)) {
    contactsId = [contactsId];
  }

  return await window.Store.WapQuery.createGroup(name, contactsId);
}


/***/ }),

/***/ "./functions/delete-conversation.js":
/*!******************************************!*\
  !*** ./functions/delete-conversation.js ***!
  \******************************************/
/*! exports provided: deleteConversation */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deleteConversation", function() { return deleteConversation; });
/**
 * @param {string} chatId Chat id
 * @param {Function} done Optional callback
 */
function deleteConversation(chatId, done) {
  let userId = new window.Store.UserConstructor(chatId, {
    intentionallyUsePrivateConstructor: true,
  });
  let conversation = WAPI.getChat(userId);

  if (!conversation) {
    if (done !== undefined) {
      done(false);
    }
    return false;
  }

  window.Store.sendDelete(conversation, false)
    .then(() => {
      if (done !== undefined) {
        done(true);
      }
    })
    .catch(() => {
      if (done !== undefined) {
        done(false);
      }
    });

  return true;
}


/***/ }),

/***/ "./functions/delete-messages.js":
/*!**************************************!*\
  !*** ./functions/delete-messages.js ***!
  \**************************************/
/*! exports provided: deleteMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deleteMessages", function() { return deleteMessages; });
/**
 * Deletes message of given message id
 * @param {string} chatId The chat id from which to delete the message.
 * @param {string[]} messageArray The specific message id of the message to be deleted
 * @param {boolean} onlyLocal If it should only delete locally (message remains on the other recipienct's phone). Defaults to false.
 * @param {Function} done Optional callback
 */
function deleteMessages(chatId, messageArray, onlyLocal, done) {
  const userId = new Store.WidFactory.createWid(chatId);
  const conversation = WAPI.getChat(userId);
  if (!conversation) {
    if (done !== undefined) {
      done(false);
    }
    return false;
  }

  if (!Array.isArray(messageArray)) {
    messageArray = [messageArray];
  }

  let messagesToDelete = messageArray
    .map((msgId) =>
      typeof msgId == 'string' ? window.Store.Msg.get(msgId) : msgId
    )
    .filter((x) => x);
  if (messagesToDelete.length == 0) return true;
  let jobs = onlyLocal
    ? [conversation.sendDeleteMsgs(messagesToDelete, conversation)]
    : [
        conversation.sendRevokeMsgs(
          messagesToDelete.filter((msg) => msg.isSentByMe),
          conversation
        ),
        conversation.sendDeleteMsgs(
          messagesToDelete.filter((msg) => !msg.isSentByMe),
          conversation
        ),
      ];
  return Promise.all(jobs).then((_) => {
    if (done !== undefined) {
      done(true);
    }
    return true;
  });
}


/***/ }),

/***/ "./functions/demote-participant.js":
/*!*****************************************!*\
  !*** ./functions/demote-participant.js ***!
  \*****************************************/
/*! exports provided: demoteParticipant */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "demoteParticipant", function() { return demoteParticipant; });
/**
 * Demotes admin privileges of participant
 * @param {string} groupId Chat id ('0000000000-00000000@g.us')
 * @param {string} participantId Participant id'000000000000@c.us'
 * @param {Function} done Optional callback
 */
async function demoteParticipant(groupId, participantId, done) {
  return window.Store.WapQuery.demoteParticipants(groupId, [
    participantId,
  ]).then(() => {
    const chat = Store.Chat.get(groupId);
    const participant = chat.groupMetadata.participants.get(participantId);
    window.Store.Participants.demoteParticipants(chat, [participant]).then(
      () => {
        done(true);
        return true;
      }
    );
  });
}


/***/ }),

/***/ "./functions/download-file-with-credentials.js":
/*!*****************************************************!*\
  !*** ./functions/download-file-with-credentials.js ***!
  \*****************************************************/
/*! exports provided: downloadFileWithCredentials */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "downloadFileWithCredentials", function() { return downloadFileWithCredentials; });
/**
 * Downloads given url file
 * @param {string} url
 * @param {Function} done Optional callback
 */
function downloadFileWithCredentials(url, done) {
  let xhr = new XMLHttpRequest();

  xhr.onload = function () {
    if (xhr.readyState == 4) {
      if (xhr.status == 200) {
        let reader = new FileReader();
        reader.readAsDataURL(xhr.response);
        reader.onload = function (e) {
          done(reader.result.substr(reader.result.indexOf(',') + 1));
        };
      } else {
        console.error(xhr.statusText);
      }
    } else {
      console.log(err);
      done(false);
    }
  };

  xhr.open('GET', url, true);
  xhr.withCredentials = true;
  xhr.responseType = 'blob';
  xhr.send(null);
}


/***/ }),

/***/ "./functions/encrypt-and-upload-file.js":
/*!**********************************************!*\
  !*** ./functions/encrypt-and-upload-file.js ***!
  \**********************************************/
/*! exports provided: encryptAndUploadFile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "encryptAndUploadFile", function() { return encryptAndUploadFile; });
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helper */ "./helper/index.js");


/**
 * Encrypts given blob
 * @param {'audio' | 'sticker' | 'video' | 'product' | 'document' | 'gif' | 'image' | 'ptt' | 'template' | 'history' | 'ppic'} type The type of file
 * @param {Blob} blob
 */
async function encryptAndUploadFile(type, blob) {
  const filehash = await Object(_helper__WEBPACK_IMPORTED_MODULE_0__["getFileHash"])(blob);
  const mediaKey = Object(_helper__WEBPACK_IMPORTED_MODULE_0__["generateMediaKey"])(32);
  const controller = new AbortController();
  const signal = controller.signal;
  const encrypted = await window.Store.UploadUtils.encryptAndUpload({
    blob,
    type,
    signal,
    mediaKey,
  });
  return {
    ...encrypted,
    clientUrl: encrypted.url,
    filehash,
    id: filehash,
    uploadhash: encrypted.encFilehash,
  };
}


/***/ }),

/***/ "./functions/forward-messages.js":
/*!***************************************!*\
  !*** ./functions/forward-messages.js ***!
  \***************************************/
/*! exports provided: forwardMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "forwardMessages", function() { return forwardMessages; });
/**
 * Forwards array of messages (could be ids or message objects)
 * @param {string} to Chat id
 * @param {string[] | Message[]} messages Array of messages to be forwarded
 * @param {boolean} skipMyMessages
 */
async function forwardMessages(to, messages, skipMyMessages) {
  if (!Array.isArray(messages)) {
    messages = [messages];
  }
  const toForward = messages
    .map((msg) => {
      if (typeof msg === 'string') {
        return window.Store.Msg.get(msg);
      } else {
        return window.Store.Msg.get(msg.id);
      }
    })
    .filter((msg) => (skipMyMessages ? !msg.__x_isSentByMe : true));

  // const userId = new window.Store.UserConstructor(to);
  const conversation = window.Store.Chat.get(to);
  return conversation.forwardMessages(toForward);
}


/***/ }),

/***/ "./functions/get-all-chats-ids.js":
/*!****************************************!*\
  !*** ./functions/get-all-chats-ids.js ***!
  \****************************************/
/*! exports provided: getAllChatIds */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllChatIds", function() { return getAllChatIds; });
/**
 * Fetches all chat IDs from store
 * @param done Callback (optional)
 * @returns {string[]} List of chat id's
 */
const getAllChatIds = function (done) {
  const chatIds = window.Store.Chat.map(
    (chat) => chat.id._serialized || chat.id
  );

  if (done !== undefined) done(chatIds);
  return chatIds;
};


/***/ }),

/***/ "./functions/get-all-chats-with-messages.js":
/*!**************************************************!*\
  !*** ./functions/get-all-chats-with-messages.js ***!
  \**************************************************/
/*! exports provided: getAllChatsWithMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllChatsWithMessages", function() { return getAllChatsWithMessages; });
/**
 * Retrieves chats with messages
 * @param {boolean} newOnly boolean
 * @param {Function} done callback
 */
async function getAllChatsWithMessages(newOnly, done) {
  const x = [];
  if (newOnly) {
    x.push(
      WAPI.getAllChatsWithNewMsg().map((c) => WAPI.getChat(c.id._serialized))
    );
  } else {
    x.push(WAPI.getAllChatIds().map((c) => WAPI.getChat(c)));
  }
  const _result = (await Promise.all(x)).flatMap((x) => x);
  const result = JSON.stringify(_result);
  return JSON.parse(result);
}


/***/ }),

/***/ "./functions/get-all-chats.js":
/*!************************************!*\
  !*** ./functions/get-all-chats.js ***!
  \************************************/
/*! exports provided: getAllChats */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllChats", function() { return getAllChats; });
/**
 * Fetches all chat objects from store
 * @param done Callback (optional)
 * @returns {Chat[]} Array of chat objects
 */
const getAllChats = function (done) {
  const chats = window.Store.Chat.map((chat) => WAPI._serializeChatObj(chat));

  if (done !== undefined) done(chats);
  return chats;
};


/***/ }),

/***/ "./functions/get-all-contacts.js":
/*!***************************************!*\
  !*** ./functions/get-all-contacts.js ***!
  \***************************************/
/*! exports provided: getAllContacts */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllContacts", function() { return getAllContacts; });
/**
 * Retrieves all contacts
 * @param {Function} done Callback function (optional)
 * * @returns {Array} List of contacts
 */
const getAllContacts = function (done) {
  const contacts = window.Store.Contact.map((contact) =>
    WAPI._serializeContactObj(contact)
  );

  if (done !== undefined) done(contacts);
  return contacts;
};


/***/ }),

/***/ "./functions/get-all-group-metadata.js":
/*!*********************************************!*\
  !*** ./functions/get-all-group-metadata.js ***!
  \*********************************************/
/*! exports provided: getAllGroupMetadata */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllGroupMetadata", function() { return getAllGroupMetadata; });
/**
 * Fetches all group metadata objects from store
 * @param {Function} done Optional callback
 */
function getAllGroupMetadata(done) {
  const groupData = window.Store.GroupMetadata.map(
    (groupData) => groupData.all
  );

  if (done !== undefined) done(groupData);
  return groupData;
}


/***/ }),

/***/ "./functions/get-all-groups.js":
/*!*************************************!*\
  !*** ./functions/get-all-groups.js ***!
  \*************************************/
/*! exports provided: getAllGroups */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllGroups", function() { return getAllGroups; });
/**
 * Retrieves all groups
 * @param {Function} done callback
 * @returns {Array} List of chats
 */
function getAllGroups(done) {
  const groups = window.Store.Chat.filter((chat) => chat.isGroup);

  if (done !== undefined) done(groups);
  return groups;
}


/***/ }),

/***/ "./functions/get-all-messages-in-chat.js":
/*!***********************************************!*\
  !*** ./functions/get-all-messages-in-chat.js ***!
  \***********************************************/
/*! exports provided: getAllMessagesInChat */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllMessagesInChat", function() { return getAllMessagesInChat; });
/**
 * @param {string} id Chat id
 * @param {boolean} includeMe
 * @param {boolean} includeNotifications
 * @param {Function} done Optional callback
 */
function getAllMessagesInChat(
  id,
  includeMe,
  includeNotifications,
  done
) {
  const chat = WAPI.getChat(id);
  let output = [];
  const messages = chat.msgs._models;

  for (const i in messages) {
    if (i === 'remove') {
      continue;
    }
    const messageObj = messages[i];

    let message = WAPI.processMessageObj(
      messageObj,
      includeMe,
      includeNotifications
    );
    if (message) output.push(message);
  }
  if (done !== undefined) done(output);
  return output;
}


/***/ }),

/***/ "./functions/get-all-new-messages.js":
/*!*******************************************!*\
  !*** ./functions/get-all-new-messages.js ***!
  \*******************************************/
/*! exports provided: getAllNewMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllNewMessages", function() { return getAllNewMessages; });
/* harmony import */ var _get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get-chats-with-new-messages */ "./functions/get-chats-with-new-messages.js");


/**
 * Retrieves all new messages
 * TODO: Test, seems to be written incorrectly
 */
const getAllNewMessages = function () {
  const _newMessages = JSON.stringify(
    Object(_get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_0__["getAllChatsWithNewMessages"])()
      .map((c) => WAPI.getChat(c.id._serialized))
      .map((c) => c.msgs._models.filter((x) => x.isNewMsg)) || []
  );

  return JSON.parse(_newMessages);
};


/***/ }),

/***/ "./functions/get-all-unread-messages.js":
/*!**********************************************!*\
  !*** ./functions/get-all-unread-messages.js ***!
  \**********************************************/
/*! exports provided: getAllUnreadMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllUnreadMessages", function() { return getAllUnreadMessages; });
/* harmony import */ var _get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get-chats-with-new-messages */ "./functions/get-chats-with-new-messages.js");


/**
 * Retrieves undread messages
 * x.ack === -1
 * TODO: Test this fn, seems incorrect, should not be async
 */
const getAllUnreadMessages = async function () {
  const _partials = JSON.stringify(
    Object(_get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_0__["getAllChatsWithNewMessages"])()
      .map((c) => WAPI.getChat(c.id._serialized))
      .map((c) => c.msgs._models.filter((x) => x.ack === -1))
      .flatMap((x) => x) || []
  );

  const partials = JSON.parse(_partials);
  return partials;
};


/***/ }),

/***/ "./functions/get-battery-level.js":
/*!****************************************!*\
  !*** ./functions/get-battery-level.js ***!
  \****************************************/
/*! exports provided: getBatteryLevel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getBatteryLevel", function() { return getBatteryLevel; });
/**
 * Retrives battery level
 * If plugged in, it will return 100%
 * @returns {number}
 */
function getBatteryLevel() {
  if (window.Store.Conn.plugged) {
    return 100;
  }
  output = window.Store.Conn.battery;
  if (done !== undefined) {
    done(output);
  }
  return output;
}


/***/ }),

/***/ "./functions/get-chat-by-id.js":
/*!*************************************!*\
  !*** ./functions/get-chat-by-id.js ***!
  \*************************************/
/*! exports provided: getChatById */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getChatById", function() { return getChatById; });
/**
 * Retrieves a chat by given id
 * @param {string} id
 * @param {Function} done optional callback
 */
function getChatById(id, done) {
  let found = WAPI.getChat(id);
  if (found) {
    found = WAPI._serializeChatObj(found);
  } else {
    found = false;
  }

  if (done !== undefined) done(found);
  return found;
}


/***/ }),

/***/ "./functions/get-chat-by-name.js":
/*!***************************************!*\
  !*** ./functions/get-chat-by-name.js ***!
  \***************************************/
/*! exports provided: getChatByName */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getChatByName", function() { return getChatByName; });
/**
 * Retrieves chat by its name
 * @param {string} name Chat name
 * @param {Function} done callback
 */
function getChatByName(name, done) {
  const found = window.Store.Chat.find((chat) => chat.name === name);
  if (done !== undefined) done(found);
  return found;
}


/***/ }),

/***/ "./functions/get-chat.js":
/*!*******************************!*\
  !*** ./functions/get-chat.js ***!
  \*******************************/
/*! exports provided: getChat */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getChat", function() { return getChat; });
/**
 * Retrieves chat by its id
 * @param {*} id Id of the chat
 * @param {*} done Callback
 * @returns {Chat} object
 */
function getChat(id, done) {
  id = typeof id == 'string' ? id : id._serialized;
  const found = window.Store.Chat.get(id);
  if (found)
    found.sendMessage = found.sendMessage
      ? found.sendMessage
      : function () {
          return window.Store.sendMessage.apply(this, arguments);
        };
  if (done !== undefined) done(found);
  return found;
}


/***/ }),

/***/ "./functions/get-chats-with-new-messages.js":
/*!**************************************************!*\
  !*** ./functions/get-chats-with-new-messages.js ***!
  \**************************************************/
/*! exports provided: getAllChatsWithNewMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getAllChatsWithNewMessages", function() { return getAllChatsWithNewMessages; });
/* harmony import */ var _has_unread_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./has-unread-messages */ "./functions/has-unread-messages.js");


/**
 * Retrieves chats with undread/new messages
 * @param {*} done
 * @returns {Chat[]} chat list
 */
const getAllChatsWithNewMessages = function (done) {
  const chats = window.Store.Chat.filter(_has_unread_messages__WEBPACK_IMPORTED_MODULE_0__["hasUndreadMessages"]).map((chat) =>
    WAPI._serializeChatObj(chat)
  );

  if (done !== undefined) done(chats);
  return chats;
};


/***/ }),

/***/ "./functions/get-common-groups.js":
/*!****************************************!*\
  !*** ./functions/get-common-groups.js ***!
  \****************************************/
/*! exports provided: getCommonGroups */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getCommonGroups", function() { return getCommonGroups; });
/**
 * Retrieves common groups of given participant
 * @param {string} participantId
 * @param {Function} done Optional callback
 */
async function getCommonGroups(participantId, done) {
  let output = [];
  groups = window.WAPI.getAllGroups();
  for (let idx in groups) {
    try {
      participants = await window.WAPI.getGroupParticipantIDs(groups[idx].id);
      if (
        participants.filter((participant) => participant == participantId)
          .length
      ) {
        output.push(groups[idx]);
      }
    } catch (err) {
      console.log('Error in group:');
      console.log(groups[idx]);
      console.log(err);
    }
  }

  if (done !== undefined) {
    done(output);
  }
  return output;
}


/***/ }),

/***/ "./functions/get-contact.js":
/*!**********************************!*\
  !*** ./functions/get-contact.js ***!
  \**********************************/
/*! exports provided: getContact */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getContact", function() { return getContact; });
/**
 * Fetches contact object from store by ID
 * @param {string} id constact id
 * @param {Function} done Callback (optional)
 * @returns {Contact} contact object
 */
const getContact = function (id, done) {
  const found = window.Store.Contact.get(id);

  if (done !== undefined) done(window.WAPI._serializeContactObj(found));
  return window.WAPI._serializeContactObj(found);
};


/***/ }),

/***/ "./functions/get-group-admins.js":
/*!***************************************!*\
  !*** ./functions/get-group-admins.js ***!
  \***************************************/
/*! exports provided: getGroupAdmins */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGroupAdmins", function() { return getGroupAdmins; });
/* harmony import */ var _get_group_participants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get-group-participants */ "./functions/get-group-participants.js");


/**
 * Retrieves group admins
 * @param {string} id Group id
 * @param {Function} done Optional callback
 */
async function getGroupAdmins(id, done) {
  const output = (await Object(_get_group_participants__WEBPACK_IMPORTED_MODULE_0__["_getGroupParticipants"])(id))
    .filter((participant) => participant.isAdmin)
    .map((admin) => admin.id);

  if (done !== undefined) done(output);
  return output;
}


/***/ }),

/***/ "./functions/get-group-invite-link.js":
/*!********************************************!*\
  !*** ./functions/get-group-invite-link.js ***!
  \********************************************/
/*! exports provided: getGroupInviteLink */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGroupInviteLink", function() { return getGroupInviteLink; });
/**
 * Generates group invite link
 * @param {string} chatId
 * @returns {string} Group invite link
 */
async function getGroupInviteLink(chatId) {
  var chat = Store.Chat.get(chatId);
  if (!chat.isGroup) return '';
  await Store.GroupInvite.queryGroupInviteCode(chat);
  return `https://chat.whatsapp.com/${chat.inviteCode}`;
}


/***/ }),

/***/ "./functions/get-group-metadata.js":
/*!*****************************************!*\
  !*** ./functions/get-group-metadata.js ***!
  \*****************************************/
/*! exports provided: getGroupMetadata */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGroupMetadata", function() { return getGroupMetadata; });
/**
 * Fetches group metadata object from store by ID
 * @param {string} id Group id
 * @param {Function} done Optional callback
 * @returns Group metadata object
 */
async function getGroupMetadata(id, done) {
  let output = window.Store.GroupMetadata.find(id);
  if (done !== undefined) done(output);
  return output;
}


/***/ }),

/***/ "./functions/get-group-participant-ids.js":
/*!************************************************!*\
  !*** ./functions/get-group-participant-ids.js ***!
  \************************************************/
/*! exports provided: getGroupParticipantIDs */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGroupParticipantIDs", function() { return getGroupParticipantIDs; });
/* harmony import */ var _get_group_participants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get-group-participants */ "./functions/get-group-participants.js");


/**
 * Fetches IDs of group participants
 * @param {string} groupId Group id
 * @param {Function} done Optional callback
 * @returns {Promise.<Array|*>} Yields list of IDs
 */
async function getGroupParticipantIDs(groupId, done) {
  const output = (await Object(_get_group_participants__WEBPACK_IMPORTED_MODULE_0__["_getGroupParticipants"])(groupId)).map(
    (participant) => participant.id
  );

  if (done !== undefined) done(output);
  return output;
}


/***/ }),

/***/ "./functions/get-group-participants.js":
/*!*********************************************!*\
  !*** ./functions/get-group-participants.js ***!
  \*********************************************/
/*! exports provided: _getGroupParticipants */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_getGroupParticipants", function() { return _getGroupParticipants; });
/**
 * Fetches group participants
 * @param {string} id Group id
 */
async function _getGroupParticipants(id) {
  const metadata = await WAPI.getGroupMetadata(id);
  return metadata.participants;
}


/***/ }),

/***/ "./functions/get-host.js":
/*!*******************************!*\
  !*** ./functions/get-host.js ***!
  \*******************************/
/*! exports provided: getHost */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getHost", function() { return getHost; });
/**
 * Returns an object with all of your host device details
 */
function getHost() {
  return Store.Me.attributes;
}


/***/ }),

/***/ "./functions/get-me.js":
/*!*****************************!*\
  !*** ./functions/get-me.js ***!
  \*****************************/
/*! exports provided: getMe */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getMe", function() { return getMe; });
/**
 * Retrieves current user object
 */
function getMe(done) {
  const rawMe = window.Store.Contact.get(window.Store.Conn.me);

  if (done !== undefined) done(rawMe.all);
  return rawMe.all;
}


/***/ }),

/***/ "./functions/get-message-by-id.js":
/*!****************************************!*\
  !*** ./functions/get-message-by-id.js ***!
  \****************************************/
/*! exports provided: getMessageById */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getMessageById", function() { return getMessageById; });
/**
 * Retrieves message by given id
 * @param {string} id Message id
 * @param {Function} done
 */
function getMessageById(id, done) {
  let result = false;
  try {
    let msg = window.Store.Msg.get(id);
    if (msg) {
      result = WAPI.processMessageObj(msg, true, true);
    }
  } catch (err) {}

  if (done !== undefined) {
    done(result);
  } else {
    return result;
  }
}


/***/ }),

/***/ "./functions/get-my-contacts.js":
/*!**************************************!*\
  !*** ./functions/get-my-contacts.js ***!
  \**************************************/
/*! exports provided: getMyContacts */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getMyContacts", function() { return getMyContacts; });
/**
 * Retrieves contacts filtered with `isMyContact` property
 * @param {Function} done Callback function (optional)
 * @returns {Array} List of contacts
 */
const getMyContacts = function (done) {
  const contacts = window.Store.Contact.filter(
    (contact) => contact.isMyContact === true
  ).map((contact) => WAPI._serializeContactObj(contact));
  if (done !== undefined) done(contacts);
  return contacts;
};


/***/ }),

/***/ "./functions/get-new-id.js":
/*!*********************************!*\
  !*** ./functions/get-new-id.js ***!
  \*********************************/
/*! exports provided: getNewId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNewId", function() { return getNewId; });
function getNewId() {
  var text = '';
  var possible =
    'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

  for (var i = 0; i < 20; i++)
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  return text;
}


/***/ }),

/***/ "./functions/get-new-message-id.js":
/*!*****************************************!*\
  !*** ./functions/get-new-message-id.js ***!
  \*****************************************/
/*! exports provided: getNewMessageId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNewMessageId", function() { return getNewMessageId; });
/**
 * Generates new message id based on given chat
 * @param {*} chatId Chat id
 */
function getNewMessageId(chatId) {
  const newMsgId = new Store.MsgKey(
    Object.assign({}, Store.Msg.models[0].__x_id)
  );

  newMsgId.fromMe = true;
  newMsgId.id = WAPI.getNewId().toUpperCase();
  newMsgId.remote = chatId;
  newMsgId._serialized = `${newMsgId.fromMe}_${newMsgId.remote}_${newMsgId.id}`;
  return newMsgId;
}


/***/ }),

/***/ "./functions/get-number-profile.js":
/*!*****************************************!*\
  !*** ./functions/get-number-profile.js ***!
  \*****************************************/
/*! exports provided: getNumberProfile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getNumberProfile", function() { return getNumberProfile; });
/**
 * Checks if a number is a valid whatsapp number
 * @param {*} id User id (you need to include the @c.us at the end.)
 * @param {*} done
 * @returns contact detial
 */
async function getNumberProfile(id, done) {
  try {
    const result = await window.Store.WapQuery.queryExist(id);
    if (result.jid === undefined) throw 404;
    const data = window.WAPI._serializeNumberStatusObj(result);
    if (data.status == 200) data.numberExists = true;
    if (done !== undefined) {
      done(window.WAPI._serializeNumberStatusObj(result));
      done(data);
    }
    return data;
  } catch (e) {
    if (done !== undefined) {
      done(
        window.WAPI._serializeNumberStatusObj({
          status: e,
          jid: id,
        })
      );
    }
    return e;
  }
}


/***/ }),

/***/ "./functions/get-profile-pic-from-server.js":
/*!**************************************************!*\
  !*** ./functions/get-profile-pic-from-server.js ***!
  \**************************************************/
/*! exports provided: getProfilePicFromServer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getProfilePicFromServer", function() { return getProfilePicFromServer; });
/**
 * @returns Url of the chat picture.
 * @param {string} id Chat id
 */
function getProfilePicFromServer(id) {
  return Store.WapQuery.profilePicFind(id).then((x) => x.eurl);
}


/***/ }),

/***/ "./functions/get-status.js":
/*!*********************************!*\
  !*** ./functions/get-status.js ***!
  \*********************************/
/*! exports provided: getStatus */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getStatus", function() { return getStatus; });
/**
 * Retrieves satus
 * @param {string} to '000000000000@c.us'
 *
 * TODO: Test this function
 */
async function getStatus(id) {
  return await Store.MyStatus.getStatus(id);
}


/***/ }),

/***/ "./functions/get-unread-messages-in-chat.js":
/*!**************************************************!*\
  !*** ./functions/get-unread-messages-in-chat.js ***!
  \**************************************************/
/*! exports provided: getUnreadMessagesInChat */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getUnreadMessagesInChat", function() { return getUnreadMessagesInChat; });
/**
 * Retrieves unread messages from chat and mark them as read as a regular UX
 * @param {string} id Chat id
 * @param {boolean} includeMe Include user client messages
 * @param {boolean} includeNotifications Include notifications
 * @param {Function} done
 */
function getUnreadMessagesInChat(
  id,
  includeMe,
  includeNotifications,
  done
) {
  // get chat and its messages
  let chat = WAPI.getChat(id);
  let messages = chat.msgs._models;

  // initialize result list
  let output = [];

  // look for unread messages, newest is at the end of array
  for (let i = messages.length - 1; i >= 0; i--) {
    // system message: skip it
    if (i === 'remove') {
      continue;
    }

    // get message
    let messageObj = messages[i];

    // found a read message: stop looking for others
    if (
      typeof messageObj.isNewMsg !== 'boolean' ||
      messageObj.isNewMsg === false
    ) {
      continue;
    } else {
      messageObj.isNewMsg = false;
      // process it
      let message = WAPI.processMessageObj(
        messageObj,
        includeMe,
        includeNotifications
      );

      // save processed message on result list
      if (message) output.push(message);
    }
  }
  // callback was passed: run it
  if (done !== undefined) done(output);
  // return result list
  return output;
}


/***/ }),

/***/ "./functions/get-unread-messages.js":
/*!******************************************!*\
  !*** ./functions/get-unread-messages.js ***!
  \******************************************/
/*! exports provided: getUnreadMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getUnreadMessages", function() { return getUnreadMessages; });
/**
 * Retrieves all undread Messages
 * @param {boolean} includeMe
 * @param {boolean} includeNotifications
 * @param {boolean} useUnreadCount
 * @param {Function} done Optional callback
 */
function getUnreadMessages(
  includeMe,
  includeNotifications,
  useUnreadCount,
  done
) {
  const chats = window.Store.Chat.models;
  const output = [];

  for (const chat in chats) {
    if (isNaN(chat)) {
      continue;
    }

    const messageGroupObj = chats[chat];
    let messageGroup = WAPI._serializeChatObj(messageGroupObj);
    messageGroup.messages = [];

    const messages = messageGroupObj.msgs._models;
    for (let i = messages.length - 1; i >= 0; i--) {
      const messageObj = messages[i];
      if (
        typeof messageObj.isNewMsg != 'boolean' ||
        messageObj.isNewMsg === false
      ) {
        continue;
      } else {
        messageObj.isNewMsg = false;
        let message = WAPI.processMessageObj(
          messageObj,
          includeMe,
          includeNotifications
        );
        if (message) {
          messageGroup.messages.push(message);
        }
      }
    }

    if (messageGroup.messages.length > 0) {
      output.push(messageGroup);
    } else {
      // No messages with isNewMsg true
      if (useUnreadCount) {
        // Will use unreadCount attribute to fetch last n messages from sender
        let n = messageGroupObj.unreadCount;
        for (let i = messages.length - 1; i >= 0; i--) {
          const messageObj = messages[i];
          if (n > 0) {
            if (!messageObj.isSentByMe) {
              let message = WAPI.processMessageObj(
                messageObj,
                includeMe,
                includeNotifications
              );
              messageGroup.messages.unshift(message);
              n -= 1;
            }
          } else if (n === -1) {
            // chat was marked as unread so will fetch last message as unread
            if (!messageObj.isSentByMe) {
              let message = WAPI.processMessageObj(
                messageObj,
                includeMe,
                includeNotifications
              );
              messageGroup.messages.unshift(message);
              break;
            }
          } else {
            // unreadCount = 0
            break;
          }
        }
        if (messageGroup.messages.length > 0) {
          messageGroupObj.unreadCount = 0; // reset unread counter
          output.push(messageGroup);
        }
      }
    }
  }
  if (done !== undefined) {
    done(output);
  }
  return output;
}


/***/ }),

/***/ "./functions/has-unread-messages.js":
/*!******************************************!*\
  !*** ./functions/has-unread-messages.js ***!
  \******************************************/
/*! exports provided: hasUndreadMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hasUndreadMessages", function() { return hasUndreadMessages; });
/**
 * Checks if given chat has new messages
 * @param {Chat} chat Chat object
 */
const hasUndreadMessages = function(chat) {
  return chat.unreadCount > 0;
};

/***/ }),

/***/ "./functions/index.js":
/*!****************************!*\
  !*** ./functions/index.js ***!
  \****************************/
/*! exports provided: areAllMessagesLoaded, clearChat, createGroup, deleteConversation, deleteMessages, downloadFileWithCredentials, encryptAndUploadFile, getAllChats, getAllChatIds, getAllChatsWithMessages, getAllContacts, getAllGroupMetadata, getAllGroups, getAllMessagesInChat, getAllNewMessages, getAllUnreadMessages, getBatteryLevel, getChat, getChatById, getChatByName, getAllChatsWithNewMessages, getCommonGroups, getContact, getGroupAdmins, getGroupInviteLink, getGroupMetadata, getGroupParticipantIDs, _getGroupParticipants, getHost, getMe, getMyContacts, getNewId, getNumberProfile, getProfilePicFromServer, getStatus, getUnreadMessages, getUnreadMessagesInChat, hasUndreadMessages, isConnected, isLoggedIn, leaveGroup, asyncLoadAllEarlierMessages, loadAllEarlierMessages, loadAndGetAllMessagesInChat, loadChatEarlierMessages, loadEarlierMessagesTillDate, processFiles, processMessageObj, revokeGroupInviteLink, sendChatstate, sendFile, sendImage, sendImageAsSticker, sendImageWithProduct, sendLocation, sendMessage, sendMessageWithTags, sendMessageWithThumb, sendMessage2, sendSeen, sendSticker, sendVideoAsGif, setMyName, setMyStatus, forwardMessages, sendContact, getNewMessageId, reply, startTyping, stopTyping, getMessageById, sendMessageToID, blockContact, unblockContact, removeParticipant, addParticipant, promoteParticipant, demoteParticipant */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _are_all_messages_loaded__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./are-all-messages-loaded */ "./functions/are-all-messages-loaded.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "areAllMessagesLoaded", function() { return _are_all_messages_loaded__WEBPACK_IMPORTED_MODULE_0__["areAllMessagesLoaded"]; });

/* harmony import */ var _clear_chat__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./clear-chat */ "./functions/clear-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "clearChat", function() { return _clear_chat__WEBPACK_IMPORTED_MODULE_1__["clearChat"]; });

/* harmony import */ var _create_group__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./create-group */ "./functions/create-group.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "createGroup", function() { return _create_group__WEBPACK_IMPORTED_MODULE_2__["createGroup"]; });

/* harmony import */ var _delete_conversation__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./delete-conversation */ "./functions/delete-conversation.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "deleteConversation", function() { return _delete_conversation__WEBPACK_IMPORTED_MODULE_3__["deleteConversation"]; });

/* harmony import */ var _delete_messages__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./delete-messages */ "./functions/delete-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "deleteMessages", function() { return _delete_messages__WEBPACK_IMPORTED_MODULE_4__["deleteMessages"]; });

/* harmony import */ var _download_file_with_credentials__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./download-file-with-credentials */ "./functions/download-file-with-credentials.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "downloadFileWithCredentials", function() { return _download_file_with_credentials__WEBPACK_IMPORTED_MODULE_5__["downloadFileWithCredentials"]; });

/* harmony import */ var _encrypt_and_upload_file__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./encrypt-and-upload-file */ "./functions/encrypt-and-upload-file.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "encryptAndUploadFile", function() { return _encrypt_and_upload_file__WEBPACK_IMPORTED_MODULE_6__["encryptAndUploadFile"]; });

/* harmony import */ var _get_all_chats__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./get-all-chats */ "./functions/get-all-chats.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllChats", function() { return _get_all_chats__WEBPACK_IMPORTED_MODULE_7__["getAllChats"]; });

/* harmony import */ var _get_all_chats_ids__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./get-all-chats-ids */ "./functions/get-all-chats-ids.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllChatIds", function() { return _get_all_chats_ids__WEBPACK_IMPORTED_MODULE_8__["getAllChatIds"]; });

/* harmony import */ var _get_all_chats_with_messages__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./get-all-chats-with-messages */ "./functions/get-all-chats-with-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllChatsWithMessages", function() { return _get_all_chats_with_messages__WEBPACK_IMPORTED_MODULE_9__["getAllChatsWithMessages"]; });

/* harmony import */ var _get_all_contacts__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./get-all-contacts */ "./functions/get-all-contacts.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllContacts", function() { return _get_all_contacts__WEBPACK_IMPORTED_MODULE_10__["getAllContacts"]; });

/* harmony import */ var _get_all_group_metadata__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./get-all-group-metadata */ "./functions/get-all-group-metadata.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllGroupMetadata", function() { return _get_all_group_metadata__WEBPACK_IMPORTED_MODULE_11__["getAllGroupMetadata"]; });

/* harmony import */ var _get_all_groups__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./get-all-groups */ "./functions/get-all-groups.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllGroups", function() { return _get_all_groups__WEBPACK_IMPORTED_MODULE_12__["getAllGroups"]; });

/* harmony import */ var _get_all_messages_in_chat__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./get-all-messages-in-chat */ "./functions/get-all-messages-in-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllMessagesInChat", function() { return _get_all_messages_in_chat__WEBPACK_IMPORTED_MODULE_13__["getAllMessagesInChat"]; });

/* harmony import */ var _get_all_new_messages__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./get-all-new-messages */ "./functions/get-all-new-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllNewMessages", function() { return _get_all_new_messages__WEBPACK_IMPORTED_MODULE_14__["getAllNewMessages"]; });

/* harmony import */ var _get_all_unread_messages__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./get-all-unread-messages */ "./functions/get-all-unread-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllUnreadMessages", function() { return _get_all_unread_messages__WEBPACK_IMPORTED_MODULE_15__["getAllUnreadMessages"]; });

/* harmony import */ var _get_battery_level__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./get-battery-level */ "./functions/get-battery-level.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getBatteryLevel", function() { return _get_battery_level__WEBPACK_IMPORTED_MODULE_16__["getBatteryLevel"]; });

/* harmony import */ var _get_chat__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./get-chat */ "./functions/get-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getChat", function() { return _get_chat__WEBPACK_IMPORTED_MODULE_17__["getChat"]; });

/* harmony import */ var _get_chat_by_id__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./get-chat-by-id */ "./functions/get-chat-by-id.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getChatById", function() { return _get_chat_by_id__WEBPACK_IMPORTED_MODULE_18__["getChatById"]; });

/* harmony import */ var _get_chat_by_name__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./get-chat-by-name */ "./functions/get-chat-by-name.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getChatByName", function() { return _get_chat_by_name__WEBPACK_IMPORTED_MODULE_19__["getChatByName"]; });

/* harmony import */ var _get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./get-chats-with-new-messages */ "./functions/get-chats-with-new-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getAllChatsWithNewMessages", function() { return _get_chats_with_new_messages__WEBPACK_IMPORTED_MODULE_20__["getAllChatsWithNewMessages"]; });

/* harmony import */ var _get_common_groups__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./get-common-groups */ "./functions/get-common-groups.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getCommonGroups", function() { return _get_common_groups__WEBPACK_IMPORTED_MODULE_21__["getCommonGroups"]; });

/* harmony import */ var _get_contact__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./get-contact */ "./functions/get-contact.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getContact", function() { return _get_contact__WEBPACK_IMPORTED_MODULE_22__["getContact"]; });

/* harmony import */ var _get_group_admins__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./get-group-admins */ "./functions/get-group-admins.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getGroupAdmins", function() { return _get_group_admins__WEBPACK_IMPORTED_MODULE_23__["getGroupAdmins"]; });

/* harmony import */ var _get_group_invite_link__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./get-group-invite-link */ "./functions/get-group-invite-link.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getGroupInviteLink", function() { return _get_group_invite_link__WEBPACK_IMPORTED_MODULE_24__["getGroupInviteLink"]; });

/* harmony import */ var _get_group_metadata__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./get-group-metadata */ "./functions/get-group-metadata.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getGroupMetadata", function() { return _get_group_metadata__WEBPACK_IMPORTED_MODULE_25__["getGroupMetadata"]; });

/* harmony import */ var _get_group_participant_ids__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./get-group-participant-ids */ "./functions/get-group-participant-ids.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getGroupParticipantIDs", function() { return _get_group_participant_ids__WEBPACK_IMPORTED_MODULE_26__["getGroupParticipantIDs"]; });

/* harmony import */ var _get_group_participants__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./get-group-participants */ "./functions/get-group-participants.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_getGroupParticipants", function() { return _get_group_participants__WEBPACK_IMPORTED_MODULE_27__["_getGroupParticipants"]; });

/* harmony import */ var _get_host__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./get-host */ "./functions/get-host.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getHost", function() { return _get_host__WEBPACK_IMPORTED_MODULE_28__["getHost"]; });

/* harmony import */ var _get_me__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! ./get-me */ "./functions/get-me.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getMe", function() { return _get_me__WEBPACK_IMPORTED_MODULE_29__["getMe"]; });

/* harmony import */ var _get_my_contacts__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! ./get-my-contacts */ "./functions/get-my-contacts.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getMyContacts", function() { return _get_my_contacts__WEBPACK_IMPORTED_MODULE_30__["getMyContacts"]; });

/* harmony import */ var _get_new_id__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! ./get-new-id */ "./functions/get-new-id.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getNewId", function() { return _get_new_id__WEBPACK_IMPORTED_MODULE_31__["getNewId"]; });

/* harmony import */ var _get_number_profile__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! ./get-number-profile */ "./functions/get-number-profile.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getNumberProfile", function() { return _get_number_profile__WEBPACK_IMPORTED_MODULE_32__["getNumberProfile"]; });

/* harmony import */ var _get_profile_pic_from_server__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! ./get-profile-pic-from-server */ "./functions/get-profile-pic-from-server.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getProfilePicFromServer", function() { return _get_profile_pic_from_server__WEBPACK_IMPORTED_MODULE_33__["getProfilePicFromServer"]; });

/* harmony import */ var _get_status__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! ./get-status */ "./functions/get-status.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getStatus", function() { return _get_status__WEBPACK_IMPORTED_MODULE_34__["getStatus"]; });

/* harmony import */ var _get_unread_messages__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! ./get-unread-messages */ "./functions/get-unread-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getUnreadMessages", function() { return _get_unread_messages__WEBPACK_IMPORTED_MODULE_35__["getUnreadMessages"]; });

/* harmony import */ var _get_unread_messages_in_chat__WEBPACK_IMPORTED_MODULE_36__ = __webpack_require__(/*! ./get-unread-messages-in-chat */ "./functions/get-unread-messages-in-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getUnreadMessagesInChat", function() { return _get_unread_messages_in_chat__WEBPACK_IMPORTED_MODULE_36__["getUnreadMessagesInChat"]; });

/* harmony import */ var _has_unread_messages__WEBPACK_IMPORTED_MODULE_37__ = __webpack_require__(/*! ./has-unread-messages */ "./functions/has-unread-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "hasUndreadMessages", function() { return _has_unread_messages__WEBPACK_IMPORTED_MODULE_37__["hasUndreadMessages"]; });

/* harmony import */ var _is_connected__WEBPACK_IMPORTED_MODULE_38__ = __webpack_require__(/*! ./is-connected */ "./functions/is-connected.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "isConnected", function() { return _is_connected__WEBPACK_IMPORTED_MODULE_38__["isConnected"]; });

/* harmony import */ var _is_logged_in__WEBPACK_IMPORTED_MODULE_39__ = __webpack_require__(/*! ./is-logged-in */ "./functions/is-logged-in.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "isLoggedIn", function() { return _is_logged_in__WEBPACK_IMPORTED_MODULE_39__["isLoggedIn"]; });

/* harmony import */ var _leave_group__WEBPACK_IMPORTED_MODULE_40__ = __webpack_require__(/*! ./leave-group */ "./functions/leave-group.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "leaveGroup", function() { return _leave_group__WEBPACK_IMPORTED_MODULE_40__["leaveGroup"]; });

/* harmony import */ var _load_all_earlier_chat_messages__WEBPACK_IMPORTED_MODULE_41__ = __webpack_require__(/*! ./load-all-earlier-chat-messages */ "./functions/load-all-earlier-chat-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "asyncLoadAllEarlierMessages", function() { return _load_all_earlier_chat_messages__WEBPACK_IMPORTED_MODULE_41__["asyncLoadAllEarlierMessages"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "loadAllEarlierMessages", function() { return _load_all_earlier_chat_messages__WEBPACK_IMPORTED_MODULE_41__["loadAllEarlierMessages"]; });

/* harmony import */ var _load_and_get_all_messages_in_chat__WEBPACK_IMPORTED_MODULE_42__ = __webpack_require__(/*! ./load-and-get-all-messages-in-chat */ "./functions/load-and-get-all-messages-in-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "loadAndGetAllMessagesInChat", function() { return _load_and_get_all_messages_in_chat__WEBPACK_IMPORTED_MODULE_42__["loadAndGetAllMessagesInChat"]; });

/* harmony import */ var _load_earlier_chat_messages__WEBPACK_IMPORTED_MODULE_43__ = __webpack_require__(/*! ./load-earlier-chat-messages */ "./functions/load-earlier-chat-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "loadChatEarlierMessages", function() { return _load_earlier_chat_messages__WEBPACK_IMPORTED_MODULE_43__["loadChatEarlierMessages"]; });

/* harmony import */ var _load_earlier_messages_til_date__WEBPACK_IMPORTED_MODULE_44__ = __webpack_require__(/*! ./load-earlier-messages-til-date */ "./functions/load-earlier-messages-til-date.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "loadEarlierMessagesTillDate", function() { return _load_earlier_messages_til_date__WEBPACK_IMPORTED_MODULE_44__["loadEarlierMessagesTillDate"]; });

/* harmony import */ var _process_files__WEBPACK_IMPORTED_MODULE_45__ = __webpack_require__(/*! ./process-files */ "./functions/process-files.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "processFiles", function() { return _process_files__WEBPACK_IMPORTED_MODULE_45__["processFiles"]; });

/* harmony import */ var _process_message_object__WEBPACK_IMPORTED_MODULE_46__ = __webpack_require__(/*! ./process-message-object */ "./functions/process-message-object.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "processMessageObj", function() { return _process_message_object__WEBPACK_IMPORTED_MODULE_46__["processMessageObj"]; });

/* harmony import */ var _revoke_invite_link__WEBPACK_IMPORTED_MODULE_47__ = __webpack_require__(/*! ./revoke-invite-link */ "./functions/revoke-invite-link.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "revokeGroupInviteLink", function() { return _revoke_invite_link__WEBPACK_IMPORTED_MODULE_47__["revokeGroupInviteLink"]; });

/* harmony import */ var _send_chat_state__WEBPACK_IMPORTED_MODULE_48__ = __webpack_require__(/*! ./send-chat-state */ "./functions/send-chat-state.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendChatstate", function() { return _send_chat_state__WEBPACK_IMPORTED_MODULE_48__["sendChatstate"]; });

/* harmony import */ var _send_file__WEBPACK_IMPORTED_MODULE_49__ = __webpack_require__(/*! ./send-file */ "./functions/send-file.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendFile", function() { return _send_file__WEBPACK_IMPORTED_MODULE_49__["sendFile"]; });

/* harmony import */ var _send_image__WEBPACK_IMPORTED_MODULE_50__ = __webpack_require__(/*! ./send-image */ "./functions/send-image.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendImage", function() { return _send_image__WEBPACK_IMPORTED_MODULE_50__["sendImage"]; });

/* harmony import */ var _send_image_as_stricker__WEBPACK_IMPORTED_MODULE_51__ = __webpack_require__(/*! ./send-image-as-stricker */ "./functions/send-image-as-stricker.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendImageAsSticker", function() { return _send_image_as_stricker__WEBPACK_IMPORTED_MODULE_51__["sendImageAsSticker"]; });

/* harmony import */ var _send_image_with_product__WEBPACK_IMPORTED_MODULE_52__ = __webpack_require__(/*! ./send-image-with-product */ "./functions/send-image-with-product.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendImageWithProduct", function() { return _send_image_with_product__WEBPACK_IMPORTED_MODULE_52__["sendImageWithProduct"]; });

/* harmony import */ var _send_location__WEBPACK_IMPORTED_MODULE_53__ = __webpack_require__(/*! ./send-location */ "./functions/send-location.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendLocation", function() { return _send_location__WEBPACK_IMPORTED_MODULE_53__["sendLocation"]; });

/* harmony import */ var _send_message__WEBPACK_IMPORTED_MODULE_54__ = __webpack_require__(/*! ./send-message */ "./functions/send-message.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendMessage", function() { return _send_message__WEBPACK_IMPORTED_MODULE_54__["sendMessage"]; });

/* harmony import */ var _send_message_with_tags__WEBPACK_IMPORTED_MODULE_55__ = __webpack_require__(/*! ./send-message-with-tags */ "./functions/send-message-with-tags.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendMessageWithTags", function() { return _send_message_with_tags__WEBPACK_IMPORTED_MODULE_55__["sendMessageWithTags"]; });

/* harmony import */ var _send_message_with_thumb__WEBPACK_IMPORTED_MODULE_56__ = __webpack_require__(/*! ./send-message-with-thumb */ "./functions/send-message-with-thumb.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendMessageWithThumb", function() { return _send_message_with_thumb__WEBPACK_IMPORTED_MODULE_56__["sendMessageWithThumb"]; });

/* harmony import */ var _send_message2__WEBPACK_IMPORTED_MODULE_57__ = __webpack_require__(/*! ./send-message2 */ "./functions/send-message2.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendMessage2", function() { return _send_message2__WEBPACK_IMPORTED_MODULE_57__["sendMessage2"]; });

/* harmony import */ var _send_seen__WEBPACK_IMPORTED_MODULE_58__ = __webpack_require__(/*! ./send-seen */ "./functions/send-seen.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendSeen", function() { return _send_seen__WEBPACK_IMPORTED_MODULE_58__["sendSeen"]; });

/* harmony import */ var _send_sticker__WEBPACK_IMPORTED_MODULE_59__ = __webpack_require__(/*! ./send-sticker */ "./functions/send-sticker.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendSticker", function() { return _send_sticker__WEBPACK_IMPORTED_MODULE_59__["sendSticker"]; });

/* harmony import */ var _send_video_as_gif__WEBPACK_IMPORTED_MODULE_60__ = __webpack_require__(/*! ./send-video-as-gif */ "./functions/send-video-as-gif.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendVideoAsGif", function() { return _send_video_as_gif__WEBPACK_IMPORTED_MODULE_60__["sendVideoAsGif"]; });

/* harmony import */ var _set_my_name__WEBPACK_IMPORTED_MODULE_61__ = __webpack_require__(/*! ./set-my-name */ "./functions/set-my-name.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "setMyName", function() { return _set_my_name__WEBPACK_IMPORTED_MODULE_61__["setMyName"]; });

/* harmony import */ var _set_my_status__WEBPACK_IMPORTED_MODULE_62__ = __webpack_require__(/*! ./set-my-status */ "./functions/set-my-status.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "setMyStatus", function() { return _set_my_status__WEBPACK_IMPORTED_MODULE_62__["setMyStatus"]; });

/* harmony import */ var _forward_messages__WEBPACK_IMPORTED_MODULE_63__ = __webpack_require__(/*! ./forward-messages */ "./functions/forward-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "forwardMessages", function() { return _forward_messages__WEBPACK_IMPORTED_MODULE_63__["forwardMessages"]; });

/* harmony import */ var _send_contact__WEBPACK_IMPORTED_MODULE_64__ = __webpack_require__(/*! ./send-contact */ "./functions/send-contact.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendContact", function() { return _send_contact__WEBPACK_IMPORTED_MODULE_64__["sendContact"]; });

/* harmony import */ var _get_new_message_id__WEBPACK_IMPORTED_MODULE_65__ = __webpack_require__(/*! ./get-new-message-id */ "./functions/get-new-message-id.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getNewMessageId", function() { return _get_new_message_id__WEBPACK_IMPORTED_MODULE_65__["getNewMessageId"]; });

/* harmony import */ var _reply__WEBPACK_IMPORTED_MODULE_66__ = __webpack_require__(/*! ./reply */ "./functions/reply.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "reply", function() { return _reply__WEBPACK_IMPORTED_MODULE_66__["reply"]; });

/* harmony import */ var _simulate_typing__WEBPACK_IMPORTED_MODULE_67__ = __webpack_require__(/*! ./simulate-typing */ "./functions/simulate-typing.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "startTyping", function() { return _simulate_typing__WEBPACK_IMPORTED_MODULE_67__["startTyping"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "stopTyping", function() { return _simulate_typing__WEBPACK_IMPORTED_MODULE_67__["stopTyping"]; });

/* harmony import */ var _get_message_by_id__WEBPACK_IMPORTED_MODULE_68__ = __webpack_require__(/*! ./get-message-by-id */ "./functions/get-message-by-id.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getMessageById", function() { return _get_message_by_id__WEBPACK_IMPORTED_MODULE_68__["getMessageById"]; });

/* harmony import */ var _send_message_to_id__WEBPACK_IMPORTED_MODULE_69__ = __webpack_require__(/*! ./send-message-to-id */ "./functions/send-message-to-id.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "sendMessageToID", function() { return _send_message_to_id__WEBPACK_IMPORTED_MODULE_69__["sendMessageToID"]; });

/* harmony import */ var _block_contact__WEBPACK_IMPORTED_MODULE_70__ = __webpack_require__(/*! ./block-contact */ "./functions/block-contact.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "blockContact", function() { return _block_contact__WEBPACK_IMPORTED_MODULE_70__["blockContact"]; });

/* harmony import */ var _unblock_contact__WEBPACK_IMPORTED_MODULE_71__ = __webpack_require__(/*! ./unblock-contact */ "./functions/unblock-contact.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "unblockContact", function() { return _unblock_contact__WEBPACK_IMPORTED_MODULE_71__["unblockContact"]; });

/* harmony import */ var _remove_participant__WEBPACK_IMPORTED_MODULE_72__ = __webpack_require__(/*! ./remove-participant */ "./functions/remove-participant.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "removeParticipant", function() { return _remove_participant__WEBPACK_IMPORTED_MODULE_72__["removeParticipant"]; });

/* harmony import */ var _add_participant__WEBPACK_IMPORTED_MODULE_73__ = __webpack_require__(/*! ./add-participant */ "./functions/add-participant.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addParticipant", function() { return _add_participant__WEBPACK_IMPORTED_MODULE_73__["addParticipant"]; });

/* harmony import */ var _promote_participant__WEBPACK_IMPORTED_MODULE_74__ = __webpack_require__(/*! ./promote-participant */ "./functions/promote-participant.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "promoteParticipant", function() { return _promote_participant__WEBPACK_IMPORTED_MODULE_74__["promoteParticipant"]; });

/* harmony import */ var _demote_participant__WEBPACK_IMPORTED_MODULE_75__ = __webpack_require__(/*! ./demote-participant */ "./functions/demote-participant.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "demoteParticipant", function() { return _demote_participant__WEBPACK_IMPORTED_MODULE_75__["demoteParticipant"]; });















































































/***/ }),

/***/ "./functions/is-connected.js":
/*!***********************************!*\
  !*** ./functions/is-connected.js ***!
  \***********************************/
/*! exports provided: isConnected */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isConnected", function() { return isConnected; });
/**
 * Check if phone is connected
 * @param {Function} done Optional callback
 */
function isConnected(done) {
  // Phone Disconnected icon appears when phone is disconnected from the tnternet
  const isConnected =
    document.querySelector('*[data-icon="alert-phone"]') !== null
      ? false
      : true;

  if (done !== undefined) done(isConnected);
  return isConnected;
}


/***/ }),

/***/ "./functions/is-logged-in.js":
/*!***********************************!*\
  !*** ./functions/is-logged-in.js ***!
  \***********************************/
/*! exports provided: isLoggedIn */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isLoggedIn", function() { return isLoggedIn; });
/**
 * @param {Function} done Optional callback
 * @returns {boolean} true if logged in, false otherwise
 */
function isLoggedIn(done) {
  // Contact always exists when logged in
  const isLogged =
    window.Store.Contact && window.Store.Contact.checksum !== undefined;

  if (done !== undefined) done(isLogged);
  return isLogged;
}


/***/ }),

/***/ "./functions/leave-group.js":
/*!**********************************!*\
  !*** ./functions/leave-group.js ***!
  \**********************************/
/*! exports provided: leaveGroup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "leaveGroup", function() { return leaveGroup; });
/**
 * Leaves group
 * @param {string} groupId The group id
 * @returns Promise
 */
async function leaveGroup(groupId) {
  groupId = typeof groupId == 'string' ? groupId : groupId._serialized;
  var group = WAPI.getChat(groupId);
  return Store.GroupActions.sendExitGroup(group);
}


/***/ }),

/***/ "./functions/load-all-earlier-chat-messages.js":
/*!*****************************************************!*\
  !*** ./functions/load-all-earlier-chat-messages.js ***!
  \*****************************************************/
/*! exports provided: loadAllEarlierMessages, asyncLoadAllEarlierMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "loadAllEarlierMessages", function() { return loadAllEarlierMessages; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asyncLoadAllEarlierMessages", function() { return asyncLoadAllEarlierMessages; });
/**
 * Loads all earlier messages of given chat id
 * @param {string} id Chat id
 * @param {Funciton} done Optional callback
 */
async function loadAllEarlierMessages(id, done) {
  const found = WAPI.getChat(id);
  while (!found.msgs.msgLoadState.noEarlierMsgs) {
    console.log('Loading...');
    await found.loadEarlierMsgs();
  }
  console.log('done');
  return true;
}

/**
 * SYNC version
 * Loads all earlier messages of given chat id
 * @param {string} id Chat id
 * @param {Funciton} done Optional callback
 */
function asyncLoadAllEarlierMessages(id, done) {
  done();
  loadAllEarlierMessages(id);
}


/***/ }),

/***/ "./functions/load-and-get-all-messages-in-chat.js":
/*!********************************************************!*\
  !*** ./functions/load-and-get-all-messages-in-chat.js ***!
  \********************************************************/
/*! exports provided: loadAndGetAllMessagesInChat */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "loadAndGetAllMessagesInChat", function() { return loadAndGetAllMessagesInChat; });
/**
 * Loads and Retrieves all Messages in a chat
 * @param {string} id Chat id
 * @param {boolean} includeMe
 * @param {boolean} includeNotifications
 * @param {Function} done Optional callback
 */
async function loadAndGetAllMessagesInChat(
  id,
  includeMe,
  includeNotifications,
  done
) {
  return WAPI.loadAllEarlierMessages(id).then((_) => {
    const chat = WAPI.getChat(id);
    let output = [];
    const messages = chat.msgs._models;

    for (const i in messages) {
      if (i === 'remove') {
        continue;
      }
      const messageObj = messages[i];

      let message = WAPI.processMessageObj(
        messageObj,
        includeMe,
        includeNotifications
      );
      if (message) output.push(message);
    }
    if (done !== undefined) done(output);
    return output;
  });
}


/***/ }),

/***/ "./functions/load-earlier-chat-messages.js":
/*!*************************************************!*\
  !*** ./functions/load-earlier-chat-messages.js ***!
  \*************************************************/
/*! exports provided: loadChatEarlierMessages */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "loadChatEarlierMessages", function() { return loadChatEarlierMessages; });
/**
 * Loads earlier chat messages from server
 * @param {string} id Chat id
 * @param {Function} done Optional callback
 */
function loadChatEarlierMessages(id, done) {
  const found = WAPI.getChat(id);
  if (done !== undefined) {
    found.loadEarlierMsgs().then(function () {
      done();
    });
  } else {
    found.loadEarlierMsgs();
  }
}


/***/ }),

/***/ "./functions/load-earlier-messages-til-date.js":
/*!*****************************************************!*\
  !*** ./functions/load-earlier-messages-til-date.js ***!
  \*****************************************************/
/*! exports provided: loadEarlierMessagesTillDate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "loadEarlierMessagesTillDate", function() { return loadEarlierMessagesTillDate; });
/**
 * Loads earlier messages from Store till given date
 * @param {string} id Chat id
 * @param {*} lastMessage UTC timestamp of last message to be loaded
 * @param {Function} done Optional callback
 */
function loadEarlierMessagesTillDate(id, lastMessage, done) {
  const found = WAPI.getChat(id);
  x = function () {
    if (
      found.msgs.models[0].t > lastMessage &&
      !found.msgs.msgLoadState.noEarlierMsgs
    ) {
      found.loadEarlierMsgs().then(x);
    } else {
      done();
    }
  };
  x();
}


/***/ }),

/***/ "./functions/process-files.js":
/*!************************************!*\
  !*** ./functions/process-files.js ***!
  \************************************/
/*! exports provided: processFiles */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "processFiles", function() { return processFiles; });
/**
 * Process files using Store MediaCollection
 * @param {Chat} chat Chat object
 * @param {any[]} blobs Blobs to process
 */
async function processFiles(chat, blobs) {
  if (!Array.isArray(blobs)) {
    blobs = [blobs];
  }

  const mediaCollection = new Store.MediaCollection(chat);
  if (Debug.VERSION !== '0.4.613') {
    blobs = blobs.map((blob) => ({ file: blob }));
  }

  await mediaCollection.processFiles(blobs, chat, 1);
  return mediaCollection;
}


/***/ }),

/***/ "./functions/process-message-object.js":
/*!*********************************************!*\
  !*** ./functions/process-message-object.js ***!
  \*********************************************/
/*! exports provided: processMessageObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "processMessageObj", function() { return processMessageObj; });
/**
 * Serializes message object
 * This is an original Whatsapp-Wrapper function
 * TODO: Check this funciton
 * @param {any} messageObj
 * @param {boolean} includeMe
 * @param {boolean} includeNotifications
 */
function processMessageObj(messageObj, includeMe, includeNotifications) {
  if (messageObj.isNotification) {
    if (includeNotifications) return WAPI._serializeMessageObj(messageObj);
    else return;
    // System message
    // (i.e. "Messages you send to this chat and calls are now secured with end-to-end encryption...")
  } else if (messageObj.id.fromMe === false || includeMe) {
    return WAPI._serializeMessageObj(messageObj);
  }
  return;
}


/***/ }),

/***/ "./functions/promote-participant.js":
/*!******************************************!*\
  !*** ./functions/promote-participant.js ***!
  \******************************************/
/*! exports provided: promoteParticipant */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "promoteParticipant", function() { return promoteParticipant; });
/**
 * Promotes participant as Admin in given group
 * @param {string} groupId Chat id ('0000000000-00000000@g.us')
 * @param {string} participantId Participant id'000000000000@c.us'
 * @param {Function} done Optional callback
 */
async function promoteParticipant(groupId, particiapntId, done) {
  const chat = Store.Chat.get(groupId);
  const participant = chat.groupMetadata.participants.get(particiapntId);
  return window.Store.Participants.promoteParticipants(chat, [
    participant,
  ]).then(() => {
    done(true);
    return true;
  });
}


/***/ }),

/***/ "./functions/remove-participant.js":
/*!*****************************************!*\
  !*** ./functions/remove-participant.js ***!
  \*****************************************/
/*! exports provided: removeParticipant */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeParticipant", function() { return removeParticipant; });
/**
 * Removes participant from group
 * @param {string} groupId Chat id ('0000000000-00000000@g.us')
 * @param {string} participantId Participant id'000000000000@c.us'
 * @param {Function} done Optional callback
 */
async function removeParticipant(groupId, participantId, done) {
  const chat = Store.Chat.get(groupId);
  const participant = chat.groupMetadata.participants.get(participantId);
  return window.Store.Participants.removeParticipants(chat, [participant]).then(
    () => {
      done(true);
      return true;
    }
  );
}


/***/ }),

/***/ "./functions/reply.js":
/*!****************************!*\
  !*** ./functions/reply.js ***!
  \****************************/
/*! exports provided: reply */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reply", function() { return reply; });
/* harmony import */ var _get_new_message_id__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get-new-message-id */ "./functions/get-new-message-id.js");


/**
 * Replys to message of given chat id
 * @param {string} chatId
 * @param {string} body
 * @param {string | Message} quotedMsg Message id or message object
 */
async function reply(chatId, body, quotedMsg) {
  if (typeof quotedMsg !== 'object') {
    quotedMsg = Store.Msg.get(quotedMsg);
  }

  const chat = Store.Chat.get(chatId);
  const extras = {
    quotedParticipant: quotedMsg.author || quotedMsg.from,
    quotedStanzaID: quotedMsg.id.id,
  };

  let tempMsg = Object.create(chat.msgs.filter((msg) => msg.__x_isSentByMe)[0]);
  const newId = Object(_get_new_message_id__WEBPACK_IMPORTED_MODULE_0__["getNewMessageId"])(chatId);
  const extend = {
    ack: 0,
    id: newId,
    local: !0,
    self: 'out',
    t: parseInt(new Date().getTime() / 1000),
    to: chatId,
    isNewMsg: !0,
    type: 'chat',
    quotedMsg,
    body,
    ...extras,
  };
  Object.assign(tempMsg, extend);
  await Store.addAndSendMsgToChat(chat, tempMsg);
}


/***/ }),

/***/ "./functions/revoke-invite-link.js":
/*!*****************************************!*\
  !*** ./functions/revoke-invite-link.js ***!
  \*****************************************/
/*! exports provided: revokeGroupInviteLink */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "revokeGroupInviteLink", function() { return revokeGroupInviteLink; });
/**
 * Revokes group invite link
 * @param {string} chatId
 */
async function revokeGroupInviteLink(chatId) {
  var chat = Store.Chat.get(chatId);
  if (!chat.isGroup) return false;
  await Store.GroupInvite.revokeGroupInvite(chat);
  return true;
}


/***/ }),

/***/ "./functions/send-chat-state.js":
/*!**************************************!*\
  !*** ./functions/send-chat-state.js ***!
  \**************************************/
/*! exports provided: sendChatstate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendChatstate", function() { return sendChatstate; });
/**
 * The state you want to set for the chat. Can be TYPING (1), RECRDING (2) or PAUSED (3);
 * @param {number} state
 * @param {string} chatId
 * @returns {boolean} true if success, false otherwise
 */
async function sendChatstate(state, chatId) {
  switch (state) {
    case 0:
      await window.Store.ChatStates.sendChatStateComposing(chatId);
      break;
    case 1:
      await window.Store.ChatStates.sendChatStateRecording(chatId);
      break;
    case 2:
      await window.Store.ChatStates.sendChatStatePaused(chatId);
      break;
    default:
      return false;
  }
  return true;
}


/***/ }),

/***/ "./functions/send-contact.js":
/*!***********************************!*\
  !*** ./functions/send-contact.js ***!
  \***********************************/
/*! exports provided: sendContact */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendContact", function() { return sendContact; });
/**
 * Sends contact card to iven chat id
 * @param {string} to Chat id
 * @param {string | string[]} contact Example: 0000@c.us | [000@c.us, 1111@c.us]
 */
function sendContact(to, contact) {
  if (!Array.isArray(contact)) {
    contact = [contact];
  }

  contact = contact.map((c) => {
    return WAPI.getChat(c).__x_contact;
  });

  if (contact.length > 1) {
    window.WAPI.getChat(to).sendContactList(contact);
  } else if (contact.length === 1) {
    window.WAPI.getChat(to).sendContact(contact[0]);
  }
}


/***/ }),

/***/ "./functions/send-file.js":
/*!********************************!*\
  !*** ./functions/send-file.js ***!
  \********************************/
/*! exports provided: sendFile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendFile", function() { return sendFile; });
/* harmony import */ var _process_files__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./process-files */ "./functions/process-files.js");
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helper */ "./helper/index.js");



/**
 * Sends image to given chat if
 * @param {string} imgBase64 base64 encoded file
 * @param {string} chatid Chat id
 * @param {string} filename
 * @param {string} caption
 * @param {Function} done Optional callback
 */
function sendFile(imgBase64, chatid, filename, caption, done) {
  const idUser = new Store.WidFactory.createWid(chatid);
  return Store.Chat.find(idUser).then((chat) => {
    var mediaBlob = Object(_helper__WEBPACK_IMPORTED_MODULE_1__["base64ToFile"])(imgBase64, filename);
    Object(_process_files__WEBPACK_IMPORTED_MODULE_0__["processFiles"])(chat, mediaBlob).then((mediaCollection) => {
      var media = mediaCollection.models[0];
      media.sendToChat(chat, { caption: caption });
      if (done !== undefined) done(true);
    });
  });
}


/***/ }),

/***/ "./functions/send-image-as-stricker.js":
/*!*********************************************!*\
  !*** ./functions/send-image-as-stricker.js ***!
  \*********************************************/
/*! exports provided: sendImageAsSticker */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendImageAsSticker", function() { return sendImageAsSticker; });
/* harmony import */ var _helper_base64_to_file__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helper/base64-to-file */ "./helper/base64-to-file.js");
/* harmony import */ var _send_sticker__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./send-sticker */ "./functions/send-sticker.js");



/**
 * Sends image as sticker to given chat id
 * @param {string} imageBase64 Image as base64
 * @param {string} chatId chat id
 * @param {*} metadata sharp metadata: (https://sharp.pixelplumbing.com/api-input#metadata)
 */
async function sendImageAsSticker(imageBase64, chatId, metadata) {
  const mediaBlob = Object(_helper_base64_to_file__WEBPACK_IMPORTED_MODULE_0__["base64ToFile"])(
    'data:image/webp;base64,' + imageBase64,
    'file.webp'
  );
  const encrypted = await window.WAPI.encryptAndUploadFile(
    'sticker',
    mediaBlob
  );

  return await Object(_send_sticker__WEBPACK_IMPORTED_MODULE_1__["sendSticker"])(encrypted, chatId, metadata);
}


/***/ }),

/***/ "./functions/send-image-with-product.js":
/*!**********************************************!*\
  !*** ./functions/send-image-with-product.js ***!
  \**********************************************/
/*! exports provided: sendImageWithProduct */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendImageWithProduct", function() { return sendImageWithProduct; });
/* harmony import */ var _process_files__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./process-files */ "./functions/process-files.js");
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helper */ "./helper/index.js");



/**
 * Sends product with product image to given chat id
 * @param {string} imgBase64 Base64 image data
 * @param {string} chatid Chat id
 * @param {string} caption Caption
 * @param {string} bizNumber string the @c.us number of the business account from which you want to grab the product
 * @param {string} productId string the id of the product within the main catalog of the aforementioned business
 * @param {Function} done Optional callback
 */
function sendImageWithProduct(
  imgBase64,
  chatid,
  caption,
  bizNumber,
  productId,
  done
) {
  Store.Catalog.findCarouselCatalog(bizNumber).then((cat) => {
    if (cat && cat[0]) {
      const product = cat[0].productCollection.get(productId);
      const temp = {
        productMsgOptions: {
          businessOwnerJid: product.catalogWid.toString({
            legacy: !0,
          }),
          productId: product.id.toString(),
          url: product.url,
          productImageCount: product.productImageCollection.length,
          title: product.name,
          description: product.description,
          currencyCode: product.currency,
          priceAmount1000: product.priceAmount1000,
          type: 'product',
        },
        caption,
      };

      var idUser = new Store.WidFactory.createWid(chatid);

      return Store.Chat.find(idUser).then((chat) => {
        var mediaBlob = Object(_helper__WEBPACK_IMPORTED_MODULE_1__["base64ToFile"])(imgBase64, filename);
        // var mc = new Store.MediaCollection(chat);
        // mc.processFiles([mediaBlob], chat, 1)
        Object(_process_files__WEBPACK_IMPORTED_MODULE_0__["processFiles"])(chat, mediaBlob).then((mc) => {
          var media = mc.models[0];
          Object.entries(temp.productMsgOptions).map(
            ([k, v]) => (media.mediaPrep._mediaData[k] = v)
          );
          media.mediaPrep.sendToChat(chat, temp);
          if (done !== undefined) done(true);
        });
      });
    }
  });
}


/***/ }),

/***/ "./functions/send-image.js":
/*!*********************************!*\
  !*** ./functions/send-image.js ***!
  \*********************************/
/*! exports provided: sendImage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendImage", function() { return sendImage; });
/* harmony import */ var _send_file__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./send-file */ "./functions/send-file.js");


/**
 * Sends image to given chat if
 * @param {string} imgBase64 base64 encoded file
 * @param {string} chatid Chat id
 * @param {string} filename
 * @param {string} caption
 * @param {Function} done Optional callback
 */
function sendImage(imgBase64, chatid, filename, caption, done) {
  return Object(_send_file__WEBPACK_IMPORTED_MODULE_0__["sendFile"])(imgBase64, chatid, filename, caption, done);
}


/***/ }),

/***/ "./functions/send-location.js":
/*!************************************!*\
  !*** ./functions/send-location.js ***!
  \************************************/
/*! exports provided: sendLocation */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendLocation", function() { return sendLocation; });
/**
 * Sends location to given chat id
 * @param {string} chatId Chat id
 * @param {string} latitude
 * @param {string} longitude
 * @param {string} caption
 */
async function sendLocation(chatId, latitude, longitude, caption) {
  const chat = Store.Chat.get(chatId);
  let tempMsg = Object.create(chat.msgs.filter((msg) => msg.__x_isSentByMe)[0]);
  const newId = window.WAPI.getNewMessageId(chatId);
  const extend = {
    ack: 0,
    id: newId,
    local: !0,
    self: 'out',
    t: parseInt(new Date().getTime() / 1000),
    to: chatId,
    isNewMsg: !0,
    type: 'location',
    lat: latitude,
    lng: longitude,
    loc: caption,
    clientUrl: undefined,
    directPath: undefined,
    filehash: undefined,
    uploadhash: undefined,
    mediaKey: undefined,
    isQuotedMsgAvailable: false,
    invis: false,
    mediaKeyTimestamp: undefined,
    mimetype: undefined,
    height: undefined,
    width: undefined,
    ephemeralStartTimestamp: undefined,
    body: undefined,
    mediaData: undefined,
    isQuotedMsgAvailable: false,
  };

  Object.assign(tempMsg, extend);
  return await Promise.all(Store.addAndSendMsgToChat(chat, tempMsg));
}


/***/ }),

/***/ "./functions/send-message-to-id.js":
/*!*****************************************!*\
  !*** ./functions/send-message-to-id.js ***!
  \*****************************************/
/*! exports provided: sendMessageToID */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendMessageToID", function() { return sendMessageToID; });
/**
 * Sends message to given chat id
 * @param {string} id
 * @param {string} message
 * @param {Function} done
 */
function sendMessageToID(id, message, done) {
  try {
    window.getContact = (id) => {
      return Store.WapQuery.queryExist(id);
    };
    window.getContact(id).then((contact) => {
      if (contact.status === 404) {
        done(true);
      } else {
        Store.Chat.find(contact.jid)
          .then((chat) => {
            chat.sendMessage(message);
            return true;
          })
          .catch((reject) => {
            if (WAPI.sendMessage(id, message)) {
              done(true);
              return true;
            } else {
              done(false);
              return false;
            }
          });
      }
    });
  } catch (e) {
    if (window.Store.Chat.length === 0) return false;

    firstChat = Store.Chat.models[0];
    var originalID = firstChat.id;
    firstChat.id =
      typeof originalID === 'string'
        ? id
        : new window.Store.UserConstructor(id, {
            intentionallyUsePrivateConstructor: true,
          });
    if (done !== undefined) {
      firstChat.sendMessage(message).then(function () {
        firstChat.id = originalID;
        done(true);
      });
      return true;
    } else {
      firstChat.sendMessage(message);
      firstChat.id = originalID;
      return true;
    }
  }
  if (done !== undefined) done(false);
  return false;
}


/***/ }),

/***/ "./functions/send-message-with-tags.js":
/*!*********************************************!*\
  !*** ./functions/send-message-with-tags.js ***!
  \*********************************************/
/*! exports provided: sendMessageWithTags */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendMessageWithTags", function() { return sendMessageWithTags; });
/**
 * Sends text message including @tag mentions
 * @param {string} to Chat id
 * @param {string} body Body message
 */
async function sendMessageWithTags(to, body) {
  var chat = to.id ? to : Store.Chat.get(to);
  var chatId = chat.id._serialized;
  var msgIveSent = chat.msgs.filter((msg) => msg.__x_isSentByMe)[0];
  if (!msgIveSent) {
    return chat.sendMessage(body);
  }

  var tempMsg = Object.create(msgIveSent);
  var newId = window.WAPI.getNewMessageId(chatId);
  var mentionedJidList =
    body
      .match(/@(\d*)/g)
      .map((x) => new Store.WidFactory.createUserWid(x.replace('@', ''))) ||
    undefined;

  var extend = {
    ack: 0,
    id: newId,
    local: !0,
    self: 'out',
    t: parseInt(new Date().getTime() / 1000),
    to: new Store.WidFactory.createWid(chatId),
    isNewMsg: !0,
    type: 'chat',
    body,
    quotedMsg: null,
    mentionedJidList,
  };

  Object.assign(tempMsg, extend);
  await Store.addAndSendMsgToChat(chat, tempMsg);
  return newId._serialized;
}


/***/ }),

/***/ "./functions/send-message-with-thumb.js":
/*!**********************************************!*\
  !*** ./functions/send-message-with-thumb.js ***!
  \**********************************************/
/*! exports provided: sendMessageWithThumb */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendMessageWithThumb", function() { return sendMessageWithThumb; });
function sendMessageWithThumb(
  thumb,
  url,
  title,
  description,
  chatId,
  done
) {
  var chatSend = WAPI.getChat(chatId);
  if (chatSend === undefined) {
    if (done !== undefined) done(false);
    return false;
  }
  var linkPreview = {
    canonicalUrl: url,
    description: description,
    matchedText: url,
    title: title,
    thumbnail: thumb,
  };
  chatSend.sendMessage(url, {
    linkPreview: linkPreview,
    mentionedJidList: [],
    quotedMsg: null,
    quotedMsgAdminGroupJid: null,
  });
  if (done !== undefined) done(true);
  return true;
}


/***/ }),

/***/ "./functions/send-message.js":
/*!***********************************!*\
  !*** ./functions/send-message.js ***!
  \***********************************/
/*! exports provided: sendMessage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendMessage", function() { return sendMessage; });
function sendMessage(id, message, done) {
  let chat = WAPI.getChat(id);
  function sleep(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
  }
  if (chat !== undefined) {
    if (done !== undefined) {
      chat.sendMessage(message).then(function () {
        let trials = 0;
        function check() {
          for (let i = chat.msgs.models.length - 1; i >= 0; i--) {
            let msg = chat.msgs.models[i];

            if (!msg.senderObj.isMe || msg.body != message) {
              continue;
            }
            done(WAPI._serializeMessageObj(msg));
            return True;
          }
          trials += 1;
          console.log(trials);
          if (trials > 30) {
            done(true);
            return;
          }
          sleep(500).then(check);
        }
        check();
      });
      return true;
    } else {
      return chat
        .sendMessage(message)
        .then((_) => chat.lastReceivedKey._serialized);
    }
  } else {
    if (done !== undefined) done(false);
    return false;
  }
}


/***/ }),

/***/ "./functions/send-message2.js":
/*!************************************!*\
  !*** ./functions/send-message2.js ***!
  \************************************/
/*! exports provided: sendMessage2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendMessage2", function() { return sendMessage2; });
function sendMessage2(id, message, done) {
  var chat = WAPI.getChat(id);
  if (chat !== undefined) {
    try {
      if (done !== undefined) {
        chat.sendMessage(message).then(function () {
          done(true);
        });
      } else {
        chat.sendMessage(message);
      }
      return true;
    } catch (error) {
      if (done !== undefined) done(false);
      return false;
    }
  }
  if (done !== undefined) done(false);
  return false;
}


/***/ }),

/***/ "./functions/send-seen.js":
/*!********************************!*\
  !*** ./functions/send-seen.js ***!
  \********************************/
/*! exports provided: sendSeen */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendSeen", function() { return sendSeen; });
/**
 * Sends seens to given chat id
 * @param {string} id Chat id
 * @param {Function} done Optional callback
 */
function sendSeen(id, done) {
  var chat = window.WAPI.getChat(id);
  if (chat !== undefined) {
    if (done !== undefined) {
      Store.SendSeen(chat, false).then(function () {
        done(true);
      });
      return true;
    } else {
      Store.SendSeen(chat, false);
      return true;
    }
  }
  if (done !== undefined) done();
  return false;
}


/***/ }),

/***/ "./functions/send-sticker.js":
/*!***********************************!*\
  !*** ./functions/send-sticker.js ***!
  \***********************************/
/*! exports provided: sendSticker */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendSticker", function() { return sendSticker; });
/**
 * Sends sticker, this method should be called with a helper like 'sendImageAsSticker'
 * @param {*} sticker Sticker
 * @param {string} chatId Chat id
 * @param {*} metadata sharp metadata (https://sharp.pixelplumbing.com/api-input#metadata)
 */
async function sendSticker(sticker, chatId, metadata) {
  var chat = Store.Chat.get(chatId);
  let stick = new window.Store.Sticker.modelClass();
  stick.__x_clientUrl = sticker.clientUrl;
  stick.__x_filehash = sticker.filehash;
  stick.__x_id = sticker.filehash;
  stick.__x_uploadhash = sticker.uploadhash;
  stick.__x_mediaKey = sticker.mediaKey;
  stick.__x_initialized = false;
  stick.__x_mediaData.mediaStage = 'INIT';
  stick.mimetype = 'image/webp';
  stick.height = metadata && metadata.height ? metadata.height : 512;
  stick.width = metadata && metadata.width ? metadata.width : 512;
  await stick.initialize();
  return await stick.sendToChat(chat);
}


/***/ }),

/***/ "./functions/send-video-as-gif.js":
/*!****************************************!*\
  !*** ./functions/send-video-as-gif.js ***!
  \****************************************/
/*! exports provided: sendVideoAsGif */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sendVideoAsGif", function() { return sendVideoAsGif; });
/* harmony import */ var _process_files__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./process-files */ "./functions/process-files.js");
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helper */ "./helper/index.js");



/**
 * Sends video as a gif to given chat id
 * @param {string} dataBase64
 * @param {string} chatid
 * @param {string} filename
 * @param {string} caption
 * @param {Function} done Optional callback
 */
function sendVideoAsGif(dataBase64, chatid, filename, caption, done) {
  // const idUser = new window.Store.UserConstructor(chatid);
  const idUser = new Store.WidFactory.createWid(chatid);
  return Store.Chat.find(idUser).then((chat) => {
    var mediaBlob = Object(_helper__WEBPACK_IMPORTED_MODULE_1__["base64ToFile"])(dataBase64, filename);
    Object(_process_files__WEBPACK_IMPORTED_MODULE_0__["processFiles"])(chat, mediaBlob).then((mc) => {
      var media = mc.models[0];
      media.mediaPrep._mediaData.isGif = true;
      media.mediaPrep._mediaData.gifAttribution = 1;
      media.mediaPrep.sendToChat(chat, { caption: caption });
      if (done !== undefined) done(true);
    });
  });
}


/***/ }),

/***/ "./functions/set-my-name.js":
/*!**********************************!*\
  !*** ./functions/set-my-name.js ***!
  \**********************************/
/*! exports provided: setMyName */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setMyName", function() { return setMyName; });
/**
 * Sets current user profile name
 * @param {string} name
 */
async function setMyName(name) {
  if (!Store.Versions.default[11].BinaryProtocol) {
    Store.Versions.default[11].BinaryProtocol = new Store.bp(11);
  }
  return await Store.Versions.default[11].setPushname(name);
}


/***/ }),

/***/ "./functions/set-my-status.js":
/*!************************************!*\
  !*** ./functions/set-my-status.js ***!
  \************************************/
/*! exports provided: setMyStatus */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setMyStatus", function() { return setMyStatus; });
/**
 * Sets current user status
 * @param {string} status
 */
function setMyStatus(status) {
  return Store.MyStatus.setMyStatus(status);
}


/***/ }),

/***/ "./functions/simulate-typing.js":
/*!**************************************!*\
  !*** ./functions/simulate-typing.js ***!
  \**************************************/
/*! exports provided: startTyping, stopTyping */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "startTyping", function() { return startTyping; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stopTyping", function() { return stopTyping; });
/**
 * Starts typing
 * @param {string} chatId
 */
async function startTyping(chatId) {
  await Store.ChatStates.sendChatStateComposing(chatId);
}

/**
 * Stops typing
 * @param {string} chatId
 */
async function stopTyping(chatId) {
  await Store.ChatStates.sendChatStatePaused(chatId);
}


/***/ }),

/***/ "./functions/unblock-contact.js":
/*!**************************************!*\
  !*** ./functions/unblock-contact.js ***!
  \**************************************/
/*! exports provided: unblockContact */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "unblockContact", function() { return unblockContact; });
/**
 * Unblocks contact
 * @param {string} id Contact id (00000000@c.us)
 * @param {Function} done Optional callback
 */
function unblockContact(id, done) {
  const contact = window.Store.Contact.get(id);
  if (contact !== undefined) {
    contact.setBlock(!1);
    done(true);
    return true;
  }
  done(false);
  return false;
}


/***/ }),

/***/ "./helper/array-buffer-to-base64.js":
/*!******************************************!*\
  !*** ./helper/array-buffer-to-base64.js ***!
  \******************************************/
/*! exports provided: arrayBufferToBase64 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "arrayBufferToBase64", function() { return arrayBufferToBase64; });
/**
 * Optimized Arraybuffer to Base64 converter
 * @param {ArrayBuffer} arrayBuffer
 */
function arrayBufferToBase64(arrayBuffer) {
  var base64 = '';
  var encodings =
    'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

  var bytes = new Uint8Array(arrayBuffer);
  var byteLength = bytes.byteLength;
  var byteRemainder = byteLength % 3;
  var mainLength = byteLength - byteRemainder;

  var a, b, c, d;
  var chunk;

  // Main loop deals with bytes in chunks of 3
  for (var i = 0; i < mainLength; i = i + 3) {
    // Combine the three bytes into a single integer
    chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];

    // Use bitmasks to extract 6-bit segments from the triplet
    a = (chunk & 16515072) >> 18; // 16515072 = (2^6 - 1) << 18
    b = (chunk & 258048) >> 12; // 258048   = (2^6 - 1) << 12
    c = (chunk & 4032) >> 6; // 4032     = (2^6 - 1) << 6
    d = chunk & 63; // 63       = 2^6 - 1

    // Convert the raw binary segments to the appropriate ASCII encoding
    base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d];
  }

  // Deal with the remaining bytes and padding
  if (byteRemainder == 1) {
    chunk = bytes[mainLength];

    a = (chunk & 252) >> 2; // 252 = (2^6 - 1) << 2

    // Set the 4 least significant bits to zero
    b = (chunk & 3) << 4; // 3   = 2^2 - 1

    base64 += encodings[a] + encodings[b] + '==';
  } else if (byteRemainder == 2) {
    chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1];

    a = (chunk & 64512) >> 10; // 64512 = (2^6 - 1) << 10
    b = (chunk & 1008) >> 4; // 1008  = (2^6 - 1) << 4

    // Set the 2 least significant bits to zero
    c = (chunk & 15) << 2; // 15    = 2^4 - 1

    base64 += encodings[a] + encodings[b] + encodings[c] + '=';
  }
  return base64;
}


/***/ }),

/***/ "./helper/base64-to-file.js":
/*!**********************************!*\
  !*** ./helper/base64-to-file.js ***!
  \**********************************/
/*! exports provided: base64ToFile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "base64ToFile", function() { return base64ToFile; });
/**
 * Converts base64 string to a file
 * @returns The file
 * @param {string} base64
 * @param {string} filename
 */
function base64ToFile(base64, filename) {
  var arr = base64.split(',');
  var mime = arr[0].match(/:(.*?);/)[1];
  var bstr = atob(arr[1]);
  var n = bstr.length;
  var u8arr = new Uint8Array(n);

  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }

  return new File([u8arr], filename, { type: mime });
}


/***/ }),

/***/ "./helper/generate-media-key.js":
/*!**************************************!*\
  !*** ./helper/generate-media-key.js ***!
  \**************************************/
/*! exports provided: generateMediaKey */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "generateMediaKey", function() { return generateMediaKey; });
/**
 * Generates media key
 * @param {number} length
 */
function generateMediaKey(length) {
  let result = '';
  let characters =
    'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
  for (let i = 0; i < length; i++) {
    result += characters.charAt(Math.floor(Math.random() * characters.length));
  }
  return result;
}


/***/ }),

/***/ "./helper/get-file-hash.js":
/*!*********************************!*\
  !*** ./helper/get-file-hash.js ***!
  \*********************************/
/*! exports provided: getFileHash */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getFileHash", function() { return getFileHash; });
/* harmony import */ var _jssha__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../jssha */ "./jssha/index.js");
/* harmony import */ var _jssha__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jssha__WEBPACK_IMPORTED_MODULE_0__);


/**
 * Retrieves given file hash (SHA-256 -> Base64)
 * @param {Blob} data
 */
async function getFileHash(data) {
  let buffer = await data.arrayBuffer();
  var sha = new _jssha__WEBPACK_IMPORTED_MODULE_0__('SHA-256', 'ARRAYBUFFER');
  sha.update(buffer);
  return sha.getHash('B64');
}


/***/ }),

/***/ "./helper/index.js":
/*!*************************!*\
  !*** ./helper/index.js ***!
  \*************************/
/*! exports provided: base64ToFile, getFileHash, generateMediaKey, arrayBufferToBase64 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _base64_to_file__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./base64-to-file */ "./helper/base64-to-file.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "base64ToFile", function() { return _base64_to_file__WEBPACK_IMPORTED_MODULE_0__["base64ToFile"]; });

/* harmony import */ var _get_file_hash__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./get-file-hash */ "./helper/get-file-hash.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "getFileHash", function() { return _get_file_hash__WEBPACK_IMPORTED_MODULE_1__["getFileHash"]; });

/* harmony import */ var _generate_media_key__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./generate-media-key */ "./helper/generate-media-key.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "generateMediaKey", function() { return _generate_media_key__WEBPACK_IMPORTED_MODULE_2__["generateMediaKey"]; });

/* harmony import */ var _array_buffer_to_base64__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./array-buffer-to-base64 */ "./helper/array-buffer-to-base64.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "arrayBufferToBase64", function() { return _array_buffer_to_base64__WEBPACK_IMPORTED_MODULE_3__["arrayBufferToBase64"]; });







/***/ }),

/***/ "./jssha/index.js":
/*!************************!*\
  !*** ./jssha/index.js ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
var __WEBPACK_AMD_DEFINE_RESULT__;/*
 A JavaScript implementation of the SHA family of hashes, as
 defined in FIPS PUB 180-4 and FIPS PUB 202, as well as the corresponding
 HMAC implementation as defined in FIPS PUB 198a

 Copyright 2008-2020 Brian Turek, 1998-2009 Paul Johnston & Contributors
 Distributed under the BSD License
 See http://caligatio.github.com/jsSHA/ for more information
*/

(function (aa) {
  function C(e, b, a) {
    var k = 0,
      h = [],
      l = 0,
      g,
      m,
      c,
      f,
      n,
      q,
      u,
      r,
      I = !1,
      v = [],
      x = [],
      t,
      y = !1,
      z = !1,
      w = -1;
    a = a || {};
    g = a.encoding || 'UTF8';
    t = a.numRounds || 1;
    if (t !== parseInt(t, 10) || 1 > t)
      throw Error('numRounds must a integer >= 1');
    if ('SHA-1' === e)
      (n = 512),
        (q = K),
        (u = ba),
        (f = 160),
        (r = function (b) {
          return b.slice();
        });
    else if (0 === e.lastIndexOf('SHA-', 0))
      if (
        ((q = function (b, k) {
          return L(b, k, e);
        }),
        (u = function (b, k, h, a) {
          var d, f;
          if ('SHA-224' === e || 'SHA-256' === e)
            (d = (((k + 65) >>> 9) << 4) + 15), (f = 16);
          else if ('SHA-384' === e || 'SHA-512' === e)
            (d = (((k + 129) >>> 10) << 5) + 31), (f = 32);
          else throw Error('Unexpected error in SHA-2 implementation');
          for (; b.length <= d; ) b.push(0);
          b[k >>> 5] |= 128 << (24 - (k % 32));
          k = k + h;
          b[d] = k & 4294967295;
          b[d - 1] = (k / 4294967296) | 0;
          h = b.length;
          for (k = 0; k < h; k += f) a = L(b.slice(k, k + f), a, e);
          if ('SHA-224' === e) b = [a[0], a[1], a[2], a[3], a[4], a[5], a[6]];
          else if ('SHA-256' === e) b = a;
          else if ('SHA-384' === e)
            b = [
              a[0].a,
              a[0].b,
              a[1].a,
              a[1].b,
              a[2].a,
              a[2].b,
              a[3].a,
              a[3].b,
              a[4].a,
              a[4].b,
              a[5].a,
              a[5].b,
            ];
          else if ('SHA-512' === e)
            b = [
              a[0].a,
              a[0].b,
              a[1].a,
              a[1].b,
              a[2].a,
              a[2].b,
              a[3].a,
              a[3].b,
              a[4].a,
              a[4].b,
              a[5].a,
              a[5].b,
              a[6].a,
              a[6].b,
              a[7].a,
              a[7].b,
            ];
          else throw Error('Unexpected error in SHA-2 implementation');
          return b;
        }),
        (r = function (b) {
          return b.slice();
        }),
        'SHA-224' === e)
      )
        (n = 512), (f = 224);
      else if ('SHA-256' === e) (n = 512), (f = 256);
      else if ('SHA-384' === e) (n = 1024), (f = 384);
      else if ('SHA-512' === e) (n = 1024), (f = 512);
      else throw Error('Chosen SHA variant is not supported');
    else if (
      0 === e.lastIndexOf('SHA3-', 0) ||
      0 === e.lastIndexOf('SHAKE', 0)
    ) {
      var F = 6;
      q = D;
      r = function (b) {
        var e = [],
          a;
        for (a = 0; 5 > a; a += 1) e[a] = b[a].slice();
        return e;
      };
      w = 1;
      if ('SHA3-224' === e) (n = 1152), (f = 224);
      else if ('SHA3-256' === e) (n = 1088), (f = 256);
      else if ('SHA3-384' === e) (n = 832), (f = 384);
      else if ('SHA3-512' === e) (n = 576), (f = 512);
      else if ('SHAKE128' === e) (n = 1344), (f = -1), (F = 31), (z = !0);
      else if ('SHAKE256' === e) (n = 1088), (f = -1), (F = 31), (z = !0);
      else throw Error('Chosen SHA variant is not supported');
      u = function (b, e, a, k, h) {
        a = n;
        var d = F,
          f,
          g = [],
          l = a >>> 5,
          m = 0,
          c = e >>> 5;
        for (f = 0; f < c && e >= a; f += l)
          (k = D(b.slice(f, f + l), k)), (e -= a);
        b = b.slice(f);
        for (e %= a; b.length < l; ) b.push(0);
        f = e >>> 3;
        b[f >> 2] ^= d << ((f % 4) * 8);
        b[l - 1] ^= 2147483648;
        for (k = D(b, k); 32 * g.length < h; ) {
          b = k[m % 5][(m / 5) | 0];
          g.push(b.b);
          if (32 * g.length >= h) break;
          g.push(b.a);
          m += 1;
          0 === (64 * m) % a && D(null, k);
        }
        return g;
      };
    } else throw Error('Chosen SHA variant is not supported');
    c = M(b, g, w);
    m = A(e);
    this.setHMACKey = function (b, a, h) {
      var d;
      if (!0 === I) throw Error('HMAC key already set');
      if (!0 === y) throw Error('Cannot set HMAC key after calling update');
      if (!0 === z) throw Error('SHAKE is not supported for HMAC');
      g = (h || {}).encoding || 'UTF8';
      a = M(a, g, w)(b);
      b = a.binLen;
      a = a.value;
      d = n >>> 3;
      h = d / 4 - 1;
      if (d < b / 8) {
        for (a = u(a, b, 0, A(e), f); a.length <= h; ) a.push(0);
        a[h] &= 4294967040;
      } else if (d > b / 8) {
        for (; a.length <= h; ) a.push(0);
        a[h] &= 4294967040;
      }
      for (b = 0; b <= h; b += 1)
        (v[b] = a[b] ^ 909522486), (x[b] = a[b] ^ 1549556828);
      m = q(v, m);
      k = n;
      I = !0;
    };
    this.update = function (b) {
      var a,
        e,
        d,
        f = 0,
        g = n >>> 5;
      a = c(b, h, l);
      b = a.binLen;
      e = a.value;
      a = b >>> 5;
      for (d = 0; d < a; d += g)
        f + n <= b && ((m = q(e.slice(d, d + g), m)), (f += n));
      k += f;
      h = e.slice(f >>> 5);
      l = b % n;
      y = !0;
    };
    this.getHash = function (b, a) {
      var d, g, c, n;
      if (!0 === I) throw Error('Cannot call getHash after setting HMAC key');
      c = N(a);
      if (!0 === z) {
        if (-1 === c.shakeLen)
          throw Error('shakeLen must be specified in options');
        f = c.shakeLen;
      }
      switch (b) {
        case 'HEX':
          d = function (b) {
            return O(b, f, w, c);
          };
          break;
        case 'B64':
          d = function (b) {
            return P(b, f, w, c);
          };
          break;
        case 'BYTES':
          d = function (b) {
            return Q(b, f, w);
          };
          break;
        case 'ARRAYBUFFER':
          try {
            g = new ArrayBuffer(0);
          } catch (p) {
            throw Error('ARRAYBUFFER not supported by this environment');
          }
          d = function (b) {
            return R(b, f, w);
          };
          break;
        case 'UINT8ARRAY':
          try {
            g = new Uint8Array(0);
          } catch (p) {
            throw Error('UINT8ARRAY not supported by this environment');
          }
          d = function (b) {
            return S(b, f, w);
          };
          break;
        default:
          throw Error(
            'format must be HEX, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY'
          );
      }
      n = u(h.slice(), l, k, r(m), f);
      for (g = 1; g < t; g += 1)
        !0 === z &&
          0 !== f % 32 &&
          (n[n.length - 1] &= 16777215 >>> (24 - (f % 32))),
          (n = u(n, f, 0, A(e), f));
      return d(n);
    };
    this.getHMAC = function (b, a) {
      var d, g, c, p;
      if (!1 === I)
        throw Error('Cannot call getHMAC without first setting HMAC key');
      c = N(a);
      switch (b) {
        case 'HEX':
          d = function (b) {
            return O(b, f, w, c);
          };
          break;
        case 'B64':
          d = function (b) {
            return P(b, f, w, c);
          };
          break;
        case 'BYTES':
          d = function (b) {
            return Q(b, f, w);
          };
          break;
        case 'ARRAYBUFFER':
          try {
            d = new ArrayBuffer(0);
          } catch (v) {
            throw Error('ARRAYBUFFER not supported by this environment');
          }
          d = function (b) {
            return R(b, f, w);
          };
          break;
        case 'UINT8ARRAY':
          try {
            d = new Uint8Array(0);
          } catch (v) {
            throw Error('UINT8ARRAY not supported by this environment');
          }
          d = function (b) {
            return S(b, f, w);
          };
          break;
        default:
          throw Error(
            'outputFormat must be HEX, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY'
          );
      }
      g = u(h.slice(), l, k, r(m), f);
      p = q(x, A(e));
      p = u(g, f, n, p, f);
      return d(p);
    };
  }
  function a(a, b) {
    this.a = a;
    this.b = b;
  }
  function T(a, b, d, k) {
    var h, l, g, c, p;
    b = b || [0];
    d = d || 0;
    l = d >>> 3;
    p = -1 === k ? 3 : 0;
    for (h = 0; h < a.length; h += 1)
      (c = h + l),
        (g = c >>> 2),
        b.length <= g && b.push(0),
        (b[g] |= a[h] << (8 * (p + (c % 4) * k)));
    return { value: b, binLen: 8 * a.length + d };
  }
  function O(a, b, d, k) {
    var h = '';
    b /= 8;
    var l, g, c;
    c = -1 === d ? 3 : 0;
    for (l = 0; l < b; l += 1)
      (g = a[l >>> 2] >>> (8 * (c + (l % 4) * d))),
        (h +=
          '0123456789abcdef'.charAt((g >>> 4) & 15) +
          '0123456789abcdef'.charAt(g & 15));
    return k.outputUpper ? h.toUpperCase() : h;
  }
  function P(a, b, d, k) {
    var h = '',
      l = b / 8,
      g,
      c,
      p,
      f;
    f = -1 === d ? 3 : 0;
    for (g = 0; g < l; g += 3)
      for (
        c = g + 1 < l ? a[(g + 1) >>> 2] : 0,
          p = g + 2 < l ? a[(g + 2) >>> 2] : 0,
          p =
            (((a[g >>> 2] >>> (8 * (f + (g % 4) * d))) & 255) << 16) |
            (((c >>> (8 * (f + ((g + 1) % 4) * d))) & 255) << 8) |
            ((p >>> (8 * (f + ((g + 2) % 4) * d))) & 255),
          c = 0;
        4 > c;
        c += 1
      )
        8 * g + 6 * c <= b
          ? (h += 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.charAt(
              (p >>> (6 * (3 - c))) & 63
            ))
          : (h += k.b64Pad);
    return h;
  }
  function Q(a, b, d) {
    var k = '';
    b /= 8;
    var h, c, g;
    g = -1 === d ? 3 : 0;
    for (h = 0; h < b; h += 1)
      (c = (a[h >>> 2] >>> (8 * (g + (h % 4) * d))) & 255),
        (k += String.fromCharCode(c));
    return k;
  }
  function R(a, b, d) {
    b /= 8;
    var k,
      h = new ArrayBuffer(b),
      c,
      g;
    g = new Uint8Array(h);
    c = -1 === d ? 3 : 0;
    for (k = 0; k < b; k += 1)
      g[k] = (a[k >>> 2] >>> (8 * (c + (k % 4) * d))) & 255;
    return h;
  }
  function S(a, b, d) {
    b /= 8;
    var k,
      h = new Uint8Array(b),
      c;
    c = -1 === d ? 3 : 0;
    for (k = 0; k < b; k += 1)
      h[k] = (a[k >>> 2] >>> (8 * (c + (k % 4) * d))) & 255;
    return h;
  }
  function N(a) {
    var b = { outputUpper: !1, b64Pad: '=', shakeLen: -1 };
    a = a || {};
    b.outputUpper = a.outputUpper || !1;
    !0 === a.hasOwnProperty('b64Pad') && (b.b64Pad = a.b64Pad);
    if (!0 === a.hasOwnProperty('shakeLen')) {
      if (0 !== a.shakeLen % 8) throw Error('shakeLen must be a multiple of 8');
      b.shakeLen = a.shakeLen;
    }
    if ('boolean' !== typeof b.outputUpper)
      throw Error('Invalid outputUpper formatting option');
    if ('string' !== typeof b.b64Pad)
      throw Error('Invalid b64Pad formatting option');
    return b;
  }
  function M(a, b, d) {
    switch (b) {
      case 'UTF8':
      case 'UTF16BE':
      case 'UTF16LE':
        break;
      default:
        throw Error('encoding must be UTF8, UTF16BE, or UTF16LE');
    }
    switch (a) {
      case 'HEX':
        a = function (b, a, e) {
          var g = b.length,
            c,
            p,
            f,
            n,
            q,
            u;
          if (0 !== g % 2)
            throw Error('String of HEX type must be in byte increments');
          a = a || [0];
          e = e || 0;
          q = e >>> 3;
          u = -1 === d ? 3 : 0;
          for (c = 0; c < g; c += 2) {
            p = parseInt(b.substr(c, 2), 16);
            if (isNaN(p))
              throw Error('String of HEX type contains invalid characters');
            n = (c >>> 1) + q;
            for (f = n >>> 2; a.length <= f; ) a.push(0);
            a[f] |= p << (8 * (u + (n % 4) * d));
          }
          return { value: a, binLen: 4 * g + e };
        };
        break;
      case 'TEXT':
        a = function (a, e, c) {
          var g,
            m,
            p = 0,
            f,
            n,
            q,
            u,
            r,
            t;
          e = e || [0];
          c = c || 0;
          q = c >>> 3;
          if ('UTF8' === b)
            for (t = -1 === d ? 3 : 0, f = 0; f < a.length; f += 1)
              for (
                g = a.charCodeAt(f),
                  m = [],
                  128 > g
                    ? m.push(g)
                    : 2048 > g
                    ? (m.push(192 | (g >>> 6)), m.push(128 | (g & 63)))
                    : 55296 > g || 57344 <= g
                    ? m.push(
                        224 | (g >>> 12),
                        128 | ((g >>> 6) & 63),
                        128 | (g & 63)
                      )
                    : ((f += 1),
                      (g =
                        65536 +
                        (((g & 1023) << 10) | (a.charCodeAt(f) & 1023))),
                      m.push(
                        240 | (g >>> 18),
                        128 | ((g >>> 12) & 63),
                        128 | ((g >>> 6) & 63),
                        128 | (g & 63)
                      )),
                  n = 0;
                n < m.length;
                n += 1
              ) {
                r = p + q;
                for (u = r >>> 2; e.length <= u; ) e.push(0);
                e[u] |= m[n] << (8 * (t + (r % 4) * d));
                p += 1;
              }
          else if ('UTF16BE' === b || 'UTF16LE' === b)
            for (
              t = -1 === d ? 2 : 0,
                m =
                  ('UTF16LE' === b && 1 !== d) || ('UTF16LE' !== b && 1 === d),
                f = 0;
              f < a.length;
              f += 1
            ) {
              g = a.charCodeAt(f);
              !0 === m && ((n = g & 255), (g = (n << 8) | (g >>> 8)));
              r = p + q;
              for (u = r >>> 2; e.length <= u; ) e.push(0);
              e[u] |= g << (8 * (t + (r % 4) * d));
              p += 2;
            }
          return { value: e, binLen: 8 * p + c };
        };
        break;
      case 'B64':
        a = function (b, a, e) {
          var c = 0,
            m,
            p,
            f,
            n,
            q,
            u,
            r,
            t;
          if (-1 === b.search(/^[a-zA-Z0-9=+\/]+$/))
            throw Error('Invalid character in base-64 string');
          p = b.indexOf('=');
          b = b.replace(/\=/g, '');
          if (-1 !== p && p < b.length)
            throw Error("Invalid '=' found in base-64 string");
          a = a || [0];
          e = e || 0;
          u = e >>> 3;
          t = -1 === d ? 3 : 0;
          for (p = 0; p < b.length; p += 4) {
            q = b.substr(p, 4);
            for (f = n = 0; f < q.length; f += 1)
              (m = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.indexOf(
                q.charAt(f)
              )),
                (n |= m << (18 - 6 * f));
            for (f = 0; f < q.length - 1; f += 1) {
              r = c + u;
              for (m = r >>> 2; a.length <= m; ) a.push(0);
              a[m] |= ((n >>> (16 - 8 * f)) & 255) << (8 * (t + (r % 4) * d));
              c += 1;
            }
          }
          return { value: a, binLen: 8 * c + e };
        };
        break;
      case 'BYTES':
        a = function (b, a, e) {
          var c, m, p, f, n, q;
          a = a || [0];
          e = e || 0;
          p = e >>> 3;
          q = -1 === d ? 3 : 0;
          for (m = 0; m < b.length; m += 1)
            (c = b.charCodeAt(m)),
              (n = m + p),
              (f = n >>> 2),
              a.length <= f && a.push(0),
              (a[f] |= c << (8 * (q + (n % 4) * d)));
          return { value: a, binLen: 8 * b.length + e };
        };
        break;
      case 'ARRAYBUFFER':
        try {
          a = new ArrayBuffer(0);
        } catch (k) {
          throw Error('ARRAYBUFFER not supported by this environment');
        }
        a = function (b, a, e) {
          return T(new Uint8Array(b), a, e, d);
        };
        break;
      case 'UINT8ARRAY':
        try {
          a = new Uint8Array(0);
        } catch (k) {
          throw Error('UINT8ARRAY not supported by this environment');
        }
        a = function (b, a, e) {
          return T(b, a, e, d);
        };
        break;
      default:
        throw Error(
          'format must be HEX, TEXT, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY'
        );
    }
    return a;
  }
  function y(a, b) {
    return (a << b) | (a >>> (32 - b));
  }
  function U(e, b) {
    return 32 < b
      ? ((b -= 32),
        new a((e.b << b) | (e.a >>> (32 - b)), (e.a << b) | (e.b >>> (32 - b))))
      : 0 !== b
      ? new a((e.a << b) | (e.b >>> (32 - b)), (e.b << b) | (e.a >>> (32 - b)))
      : e;
  }
  function x(a, b) {
    return (a >>> b) | (a << (32 - b));
  }
  function t(e, b) {
    var d = null,
      d = new a(e.a, e.b);
    return (d =
      32 >= b
        ? new a(
            (d.a >>> b) | ((d.b << (32 - b)) & 4294967295),
            (d.b >>> b) | ((d.a << (32 - b)) & 4294967295)
          )
        : new a(
            (d.b >>> (b - 32)) | ((d.a << (64 - b)) & 4294967295),
            (d.a >>> (b - 32)) | ((d.b << (64 - b)) & 4294967295)
          ));
  }
  function V(e, b) {
    var d = null;
    return (d =
      32 >= b
        ? new a(e.a >>> b, (e.b >>> b) | ((e.a << (32 - b)) & 4294967295))
        : new a(0, e.a >>> (b - 32)));
  }
  function ca(a, b, d) {
    return (a & b) ^ (~a & d);
  }
  function da(e, b, d) {
    return new a((e.a & b.a) ^ (~e.a & d.a), (e.b & b.b) ^ (~e.b & d.b));
  }
  function W(a, b, d) {
    return (a & b) ^ (a & d) ^ (b & d);
  }
  function ea(e, b, d) {
    return new a(
      (e.a & b.a) ^ (e.a & d.a) ^ (b.a & d.a),
      (e.b & b.b) ^ (e.b & d.b) ^ (b.b & d.b)
    );
  }
  function fa(a) {
    return x(a, 2) ^ x(a, 13) ^ x(a, 22);
  }
  function ga(e) {
    var b = t(e, 28),
      d = t(e, 34);
    e = t(e, 39);
    return new a(b.a ^ d.a ^ e.a, b.b ^ d.b ^ e.b);
  }
  function ha(a) {
    return x(a, 6) ^ x(a, 11) ^ x(a, 25);
  }
  function ia(e) {
    var b = t(e, 14),
      d = t(e, 18);
    e = t(e, 41);
    return new a(b.a ^ d.a ^ e.a, b.b ^ d.b ^ e.b);
  }
  function ja(a) {
    return x(a, 7) ^ x(a, 18) ^ (a >>> 3);
  }
  function ka(e) {
    var b = t(e, 1),
      d = t(e, 8);
    e = V(e, 7);
    return new a(b.a ^ d.a ^ e.a, b.b ^ d.b ^ e.b);
  }
  function la(a) {
    return x(a, 17) ^ x(a, 19) ^ (a >>> 10);
  }
  function ma(e) {
    var b = t(e, 19),
      d = t(e, 61);
    e = V(e, 6);
    return new a(b.a ^ d.a ^ e.a, b.b ^ d.b ^ e.b);
  }
  function G(a, b) {
    var d = (a & 65535) + (b & 65535);
    return (
      ((((a >>> 16) + (b >>> 16) + (d >>> 16)) & 65535) << 16) | (d & 65535)
    );
  }
  function na(a, b, d, k) {
    var h = (a & 65535) + (b & 65535) + (d & 65535) + (k & 65535);
    return (
      ((((a >>> 16) + (b >>> 16) + (d >>> 16) + (k >>> 16) + (h >>> 16)) &
        65535) <<
        16) |
      (h & 65535)
    );
  }
  function H(a, b, d, k, h) {
    var c = (a & 65535) + (b & 65535) + (d & 65535) + (k & 65535) + (h & 65535);
    return (
      ((((a >>> 16) +
        (b >>> 16) +
        (d >>> 16) +
        (k >>> 16) +
        (h >>> 16) +
        (c >>> 16)) &
        65535) <<
        16) |
      (c & 65535)
    );
  }
  function oa(e, b) {
    var d, k, c;
    d = (e.b & 65535) + (b.b & 65535);
    k = (e.b >>> 16) + (b.b >>> 16) + (d >>> 16);
    c = ((k & 65535) << 16) | (d & 65535);
    d = (e.a & 65535) + (b.a & 65535) + (k >>> 16);
    k = (e.a >>> 16) + (b.a >>> 16) + (d >>> 16);
    return new a(((k & 65535) << 16) | (d & 65535), c);
  }
  function pa(e, b, d, k) {
    var c, l, g;
    c = (e.b & 65535) + (b.b & 65535) + (d.b & 65535) + (k.b & 65535);
    l = (e.b >>> 16) + (b.b >>> 16) + (d.b >>> 16) + (k.b >>> 16) + (c >>> 16);
    g = ((l & 65535) << 16) | (c & 65535);
    c =
      (e.a & 65535) +
      (b.a & 65535) +
      (d.a & 65535) +
      (k.a & 65535) +
      (l >>> 16);
    l = (e.a >>> 16) + (b.a >>> 16) + (d.a >>> 16) + (k.a >>> 16) + (c >>> 16);
    return new a(((l & 65535) << 16) | (c & 65535), g);
  }
  function qa(e, b, d, k, c) {
    var l, g, m;
    l =
      (e.b & 65535) +
      (b.b & 65535) +
      (d.b & 65535) +
      (k.b & 65535) +
      (c.b & 65535);
    g =
      (e.b >>> 16) +
      (b.b >>> 16) +
      (d.b >>> 16) +
      (k.b >>> 16) +
      (c.b >>> 16) +
      (l >>> 16);
    m = ((g & 65535) << 16) | (l & 65535);
    l =
      (e.a & 65535) +
      (b.a & 65535) +
      (d.a & 65535) +
      (k.a & 65535) +
      (c.a & 65535) +
      (g >>> 16);
    g =
      (e.a >>> 16) +
      (b.a >>> 16) +
      (d.a >>> 16) +
      (k.a >>> 16) +
      (c.a >>> 16) +
      (l >>> 16);
    return new a(((g & 65535) << 16) | (l & 65535), m);
  }
  function B(e, b) {
    return new a(e.a ^ b.a, e.b ^ b.b);
  }
  function A(e) {
    var b = [],
      d;
    if ('SHA-1' === e)
      b = [1732584193, 4023233417, 2562383102, 271733878, 3285377520];
    else if (0 === e.lastIndexOf('SHA-', 0))
      switch (
        ((b = [
          3238371032,
          914150663,
          812702999,
          4144912697,
          4290775857,
          1750603025,
          1694076839,
          3204075428,
        ]),
        (d = [
          1779033703,
          3144134277,
          1013904242,
          2773480762,
          1359893119,
          2600822924,
          528734635,
          1541459225,
        ]),
        e)
      ) {
        case 'SHA-224':
          break;
        case 'SHA-256':
          b = d;
          break;
        case 'SHA-384':
          b = [
            new a(3418070365, b[0]),
            new a(1654270250, b[1]),
            new a(2438529370, b[2]),
            new a(355462360, b[3]),
            new a(1731405415, b[4]),
            new a(41048885895, b[5]),
            new a(3675008525, b[6]),
            new a(1203062813, b[7]),
          ];
          break;
        case 'SHA-512':
          b = [
            new a(d[0], 4089235720),
            new a(d[1], 2227873595),
            new a(d[2], 4271175723),
            new a(d[3], 1595750129),
            new a(d[4], 2917565137),
            new a(d[5], 725511199),
            new a(d[6], 4215389547),
            new a(d[7], 327033209),
          ];
          break;
        default:
          throw Error('Unknown SHA variant');
      }
    else if (0 === e.lastIndexOf('SHA3-', 0) || 0 === e.lastIndexOf('SHAKE', 0))
      for (e = 0; 5 > e; e += 1)
        b[e] = [
          new a(0, 0),
          new a(0, 0),
          new a(0, 0),
          new a(0, 0),
          new a(0, 0),
        ];
    else throw Error('No SHA variants supported');
    return b;
  }
  function K(a, b) {
    var d = [],
      k,
      c,
      l,
      g,
      m,
      p,
      f;
    k = b[0];
    c = b[1];
    l = b[2];
    g = b[3];
    m = b[4];
    for (f = 0; 80 > f; f += 1)
      (d[f] =
        16 > f ? a[f] : y(d[f - 3] ^ d[f - 8] ^ d[f - 14] ^ d[f - 16], 1)),
        (p =
          20 > f
            ? H(y(k, 5), (c & l) ^ (~c & g), m, 1518500249, d[f])
            : 40 > f
            ? H(y(k, 5), c ^ l ^ g, m, 1859775393, d[f])
            : 60 > f
            ? H(y(k, 5), W(c, l, g), m, 2400959708, d[f])
            : H(y(k, 5), c ^ l ^ g, m, 3395469782, d[f])),
        (m = g),
        (g = l),
        (l = y(c, 30)),
        (c = k),
        (k = p);
    b[0] = G(k, b[0]);
    b[1] = G(c, b[1]);
    b[2] = G(l, b[2]);
    b[3] = G(g, b[3]);
    b[4] = G(m, b[4]);
    return b;
  }
  function ba(a, b, d, c) {
    var h;
    for (h = (((b + 65) >>> 9) << 4) + 15; a.length <= h; ) a.push(0);
    a[b >>> 5] |= 128 << (24 - (b % 32));
    b += d;
    a[h] = b & 4294967295;
    a[h - 1] = (b / 4294967296) | 0;
    b = a.length;
    for (h = 0; h < b; h += 16) c = K(a.slice(h, h + 16), c);
    return c;
  }
  function L(e, b, d) {
    var k,
      h,
      l,
      g,
      m,
      p,
      f,
      n,
      q,
      u,
      r,
      t,
      v,
      x,
      y,
      A,
      z,
      w,
      F,
      B,
      C,
      D,
      E = [],
      J;
    if ('SHA-224' === d || 'SHA-256' === d)
      (u = 64),
        (t = 1),
        (D = Number),
        (v = G),
        (x = na),
        (y = H),
        (A = ja),
        (z = la),
        (w = fa),
        (F = ha),
        (C = W),
        (B = ca),
        (J = c);
    else if ('SHA-384' === d || 'SHA-512' === d)
      (u = 80),
        (t = 2),
        (D = a),
        (v = oa),
        (x = pa),
        (y = qa),
        (A = ka),
        (z = ma),
        (w = ga),
        (F = ia),
        (C = ea),
        (B = da),
        (J = X);
    else throw Error('Unexpected error in SHA-2 implementation');
    d = b[0];
    k = b[1];
    h = b[2];
    l = b[3];
    g = b[4];
    m = b[5];
    p = b[6];
    f = b[7];
    for (r = 0; r < u; r += 1)
      16 > r
        ? ((q = r * t),
          (n = e.length <= q ? 0 : e[q]),
          (q = e.length <= q + 1 ? 0 : e[q + 1]),
          (E[r] = new D(n, q)))
        : (E[r] = x(z(E[r - 2]), E[r - 7], A(E[r - 15]), E[r - 16])),
        (n = y(f, F(g), B(g, m, p), J[r], E[r])),
        (q = v(w(d), C(d, k, h))),
        (f = p),
        (p = m),
        (m = g),
        (g = v(l, n)),
        (l = h),
        (h = k),
        (k = d),
        (d = v(n, q));
    b[0] = v(d, b[0]);
    b[1] = v(k, b[1]);
    b[2] = v(h, b[2]);
    b[3] = v(l, b[3]);
    b[4] = v(g, b[4]);
    b[5] = v(m, b[5]);
    b[6] = v(p, b[6]);
    b[7] = v(f, b[7]);
    return b;
  }
  function D(e, b) {
    var d,
      c,
      h,
      l,
      g = [],
      m = [];
    if (null !== e)
      for (c = 0; c < e.length; c += 2)
        b[(c >>> 1) % 5][((c >>> 1) / 5) | 0] = B(
          b[(c >>> 1) % 5][((c >>> 1) / 5) | 0],
          new a(e[c + 1], e[c])
        );
    for (d = 0; 24 > d; d += 1) {
      l = A('SHA3-');
      for (c = 0; 5 > c; c += 1) {
        h = b[c][0];
        var p = b[c][1],
          f = b[c][2],
          n = b[c][3],
          q = b[c][4];
        g[c] = new a(h.a ^ p.a ^ f.a ^ n.a ^ q.a, h.b ^ p.b ^ f.b ^ n.b ^ q.b);
      }
      for (c = 0; 5 > c; c += 1) m[c] = B(g[(c + 4) % 5], U(g[(c + 1) % 5], 1));
      for (c = 0; 5 > c; c += 1)
        for (h = 0; 5 > h; h += 1) b[c][h] = B(b[c][h], m[c]);
      for (c = 0; 5 > c; c += 1)
        for (h = 0; 5 > h; h += 1)
          l[h][(2 * c + 3 * h) % 5] = U(b[c][h], Y[c][h]);
      for (c = 0; 5 > c; c += 1)
        for (h = 0; 5 > h; h += 1)
          b[c][h] = B(
            l[c][h],
            new a(
              ~l[(c + 1) % 5][h].a & l[(c + 2) % 5][h].a,
              ~l[(c + 1) % 5][h].b & l[(c + 2) % 5][h].b
            )
          );
      b[0][0] = B(b[0][0], Z[d]);
    }
    return b;
  }
  var c, X, Y, Z;
  c = [
    1116352408,
    1899447441,
    3049323471,
    3921009573,
    961987163,
    1508970993,
    2453635748,
    2870763221,
    3624381080,
    310598401,
    607225278,
    1426881987,
    1925078388,
    2162078206,
    2614888103,
    3248222580,
    3835390401,
    4022224774,
    264347078,
    604807628,
    770255983,
    1249150122,
    1555081692,
    1996064986,
    2554220882,
    2821834349,
    2952996808,
    3210313671,
    3336571891,
    3584528711,
    113926993,
    338241895,
    666307205,
    773529912,
    1294757372,
    1396182291,
    1695183700,
    1986661051,
    2177026350,
    2456956037,
    2730485921,
    2820302411,
    3259730800,
    3345764771,
    3516065817,
    3600352804,
    4094571909,
    275423344,
    430227734,
    506948616,
    659060556,
    883997877,
    958139571,
    1322822218,
    1537002063,
    1747873779,
    1955562222,
    2024104815,
    2227730452,
    2361852424,
    2428436474,
    2756734187,
    3204031479,
    3329325298,
  ];
  X = [
    new a(c[0], 3609767458),
    new a(c[1], 602891725),
    new a(c[2], 3964484399),
    new a(c[3], 2173295548),
    new a(c[4], 4081628472),
    new a(c[5], 3053834265),
    new a(c[6], 2937671579),
    new a(c[7], 3664609560),
    new a(c[8], 2734883394),
    new a(c[9], 1164996542),
    new a(c[10], 1323610764),
    new a(c[11], 3590304994),
    new a(c[12], 4068182383),
    new a(c[13], 991336113),
    new a(c[14], 633803317),
    new a(c[15], 3479774868),
    new a(c[16], 2666613458),
    new a(c[17], 944711139),
    new a(c[18], 2341262773),
    new a(c[19], 2007800933),
    new a(c[20], 1495990901),
    new a(c[21], 1856431235),
    new a(c[22], 3175218132),
    new a(c[23], 2198950837),
    new a(c[24], 3999719339),
    new a(c[25], 766784016),
    new a(c[26], 2566594879),
    new a(c[27], 3203337956),
    new a(c[28], 1034457026),
    new a(c[29], 2466948901),
    new a(c[30], 3758326383),
    new a(c[31], 168717936),
    new a(c[32], 1188179964),
    new a(c[33], 1546045734),
    new a(c[34], 1522805485),
    new a(c[35], 2643833823),
    new a(c[36], 2343527390),
    new a(c[37], 1014477480),
    new a(c[38], 1206759142),
    new a(c[39], 344077627),
    new a(c[40], 1290863460),
    new a(c[41], 3158454273),
    new a(c[42], 3505952657),
    new a(c[43], 106217008),
    new a(c[44], 3606008344),
    new a(c[45], 1432725776),
    new a(c[46], 1467031594),
    new a(c[47], 851169720),
    new a(c[48], 3100823752),
    new a(c[49], 1363258195),
    new a(c[50], 3750685593),
    new a(c[51], 3785050280),
    new a(c[52], 3318307427),
    new a(c[53], 3812723403),
    new a(c[54], 2003034995),
    new a(c[55], 3602036899),
    new a(c[56], 1575990012),
    new a(c[57], 1125592928),
    new a(c[58], 2716904306),
    new a(c[59], 442776044),
    new a(c[60], 593698344),
    new a(c[61], 3733110249),
    new a(c[62], 2999351573),
    new a(c[63], 3815920427),
    new a(3391569614, 3928383900),
    new a(3515267271, 566280711),
    new a(3940187606, 3454069534),
    new a(4118630271, 4000239992),
    new a(116418474, 1914138554),
    new a(174292421, 2731055270),
    new a(289380356, 3203993006),
    new a(460393269, 320620315),
    new a(685471733, 587496836),
    new a(852142971, 1086792851),
    new a(1017036298, 365543100),
    new a(1126000580, 2618297676),
    new a(1288033470, 3409855158),
    new a(1501505948, 4234509866),
    new a(1607167915, 987167468),
    new a(1816402316, 1246189591),
  ];
  Z = [
    new a(0, 1),
    new a(0, 32898),
    new a(2147483648, 32906),
    new a(2147483648, 2147516416),
    new a(0, 32907),
    new a(0, 2147483649),
    new a(2147483648, 2147516545),
    new a(2147483648, 32777),
    new a(0, 138),
    new a(0, 136),
    new a(0, 2147516425),
    new a(0, 2147483658),
    new a(0, 2147516555),
    new a(2147483648, 139),
    new a(2147483648, 32905),
    new a(2147483648, 32771),
    new a(2147483648, 32770),
    new a(2147483648, 128),
    new a(0, 32778),
    new a(2147483648, 2147483658),
    new a(2147483648, 2147516545),
    new a(2147483648, 32896),
    new a(0, 2147483649),
    new a(2147483648, 2147516424),
  ];
  Y = [
    [0, 36, 3, 41, 18],
    [1, 44, 10, 45, 2],
    [62, 6, 43, 15, 61],
    [28, 55, 25, 21, 56],
    [27, 20, 39, 8, 14],
  ];
   true
    ? !(__WEBPACK_AMD_DEFINE_RESULT__ = (function () {
        return C;
      }).call(exports, __webpack_require__, exports, module),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__))
    : undefined;
})(this);


/***/ }),

/***/ "./listeners/add-all-new-messages.js":
/*!*******************************************!*\
  !*** ./listeners/add-all-new-messages.js ***!
  \*******************************************/
/*! exports provided: allNewMessagesListener */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "allNewMessagesListener", function() { return allNewMessagesListener; });
function allNewMessagesListener() {
  window.WAPI.allNewMessagesListener = (callback) =>
    window.Store.Msg.on('add', (newMessage) => {
      if (newMessage && newMessage.isNewMsg) {
        let message = window.WAPI.processMessageObj(newMessage, true, false);
        if (message) {
          callback(message);
        }
      }
    });
}


/***/ }),

/***/ "./listeners/add-new-messages.js":
/*!***************************************!*\
  !*** ./listeners/add-new-messages.js ***!
  \***************************************/
/*! exports provided: addNewMessagesListener */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addNewMessagesListener", function() { return addNewMessagesListener; });
function addNewMessagesListener() {
  window.WAPI.waitNewMessages = waitNewMessages;
}

/**
 * Registers a callback to be called when a new message arrives the WAPI.
 * @param rmCallbackAfterUse - Boolean - Specify if the callback need to be executed only once
 * @param done - function - Callback function to be called when a new message arrives.
 * @returns {boolean}
 */
function waitNewMessages(rmCallbackAfterUse = true, done) {
  window.WAPI._newMessagesCallbacks.push({
    callback: done,
    rmAfterUse: rmCallbackAfterUse,
  });
  return true;
}


/***/ }),

/***/ "./listeners/add-on-added-to-group.js":
/*!********************************************!*\
  !*** ./listeners/add-on-added-to-group.js ***!
  \********************************************/
/*! exports provided: addOnAddedToGroup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addOnAddedToGroup", function() { return addOnAddedToGroup; });
/**
 * Registers listener for the device when is added to a group
 */
function addOnAddedToGroup() {
  /**
   * Registers a callback that fires when your host phone is added to a group.
   * @param callback - function - Callback function to be called when a message acknowledgement changes. The callback returns 3 variables
   * @returns {boolean}
   */
  window.WAPI.onAddedToGroup = function (callback) {
    Store.Chat.on('add', (chatObject) => {
      if (chatObject && chatObject.isGroup) {
        callback(chatObject);
      }
    });
    return true;
  };
}


/***/ }),

/***/ "./listeners/add-on-live-location.js":
/*!*******************************************!*\
  !*** ./listeners/add-on-live-location.js ***!
  \*******************************************/
/*! exports provided: addOnLiveLocation */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addOnLiveLocation", function() { return addOnLiveLocation; });
/**
 * Regiters on live location listener
 */
function addOnLiveLocation() {
  window.WAPI.onLiveLocation = function (chatId, callback) {
    var lLChat = Store.LiveLocation.get(chatId);
    if (lLChat) {
      var validLocs = lLChat.participants.validLocations();
      validLocs.map((x) =>
        x.on('change:lastUpdated', (x, y, z) => {
          console.log(x, y, z);
          const { id, lat, lng, accuracy, degrees, speed, lastUpdated } = x;
          const l = {
            id: id.toString(),
            lat,
            lng,
            accuracy,
            degrees,
            speed,
            lastUpdated,
          };
          // console.log('newloc',l)
          callback(l);
        })
      );
      return true;
    } else {
      return false;
    }
  };
}


/***/ }),

/***/ "./listeners/add-on-new-ack.js":
/*!*************************************!*\
  !*** ./listeners/add-on-new-ack.js ***!
  \*************************************/
/*! exports provided: addOnNewAcks */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addOnNewAcks", function() { return addOnNewAcks; });
/**
 * Registers a callback to be called when a the acknowledgement state of a message changes.
 * @param callback - function - Callback function to be called when a message acknowledgement changes.
 * @returns {boolean}
 */
function addOnNewAcks() {
  window.WAPI.waitNewAcknowledgements = function (callback) {
    Store.Msg.on('change:ack', callback);
    return true;
  };
}


/***/ }),

/***/ "./listeners/add-on-participants-change.js":
/*!*************************************************!*\
  !*** ./listeners/add-on-participants-change.js ***!
  \*************************************************/
/*! exports provided: addOnParticipantsChange */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addOnParticipantsChange", function() { return addOnParticipantsChange; });
let groupParticpiantsEvents = {};

/**
 * Registers on participants change listener
 */
function addOnParticipantsChange() {
  /**
   * Registers a callback to participant changes on a certain, specific group
   * @param groupId - string - The id of the group that you want to attach the callback to.
   * @param callback - function - Callback function to be called when a message acknowledgement changes. The callback returns 3 variables
   * @returns {boolean}
   */
  window.WAPI.onParticipantsChanged = function (groupId, callback) {
    const subtypeEvents = [
      'invite',
      'add',
      'remove',
      'leave',
      'promote',
      'demote',
    ];
    const chat = window.Store.Chat.get(groupId);
    //attach all group Participants to the events object as 'add'
    const metadata = window.Store.GroupMetadata.get(groupId);
    if (!groupParticpiantsEvents[groupId]) {
      groupParticpiantsEvents[groupId] = {};
      metadata.participants.forEach((participant) => {
        groupParticpiantsEvents[groupId][participant.id.toString()] = {
          subtype: 'add',
          from: metadata.owner,
        };
      });
    }
    let i = 0;
    chat.on('change:groupMetadata.participants', (_) =>
      chat.on('all', (x, y) => {
        const { isGroup, previewMessage } = y;
        if (
          isGroup &&
          x === 'change' &&
          previewMessage &&
          previewMessage.type === 'gp2' &&
          subtypeEvents.includes(previewMessage.subtype)
        ) {
          const { subtype, from, recipients } = previewMessage;
          const rec = recipients[0].toString();
          if (
            groupParticpiantsEvents[groupId][rec] &&
            groupParticpiantsEvents[groupId][recipients[0]].subtype == subtype
          ) {
            //ignore, this is a duplicate entry
            // console.log('duplicate event')
          } else {
            //ignore the first message
            if (i == 0) {
              //ignore it, plus 1,
              i++;
            } else {
              groupParticpiantsEvents[groupId][rec] = { subtype, from };
              //fire the callback
              // // previewMessage.from.toString()
              // x removed y
              // x added y
              callback({
                by: from.toString(),
                action: subtype,
                who: recipients,
              });
              chat.off('all', this);
              i = 0;
            }
          }
        }
      })
    );
    return true;
  };
}


/***/ }),

/***/ "./listeners/add-on-state-change.js":
/*!******************************************!*\
  !*** ./listeners/add-on-state-change.js ***!
  \******************************************/
/*! exports provided: addOnStateChange */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addOnStateChange", function() { return addOnStateChange; });
/**
 * Registers a callback for state change event
 * It could be [UNLAUNCHED, OPENING, PAIRING, CONNECTED, TIMEOUT]
 * @param callback - function - Callback function to be called when the device state changes
 */

function addOnStateChange() {
  window.WAPI.onStateChange = function (callback) {
    window.Store.State.default.on('change:state', callback);
    return true;
  };
}


/***/ }),

/***/ "./listeners/index.js":
/*!****************************!*\
  !*** ./listeners/index.js ***!
  \****************************/
/*! exports provided: initNewMessagesListener, addNewMessagesListener, allNewMessagesListener, addOnStateChange, addOnNewAcks, addOnLiveLocation, addOnParticipantsChange, addOnAddedToGroup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _init_listeners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./init-listeners */ "./listeners/init-listeners.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "initNewMessagesListener", function() { return _init_listeners__WEBPACK_IMPORTED_MODULE_0__["initNewMessagesListener"]; });

/* harmony import */ var _add_new_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./add-new-messages */ "./listeners/add-new-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addNewMessagesListener", function() { return _add_new_messages__WEBPACK_IMPORTED_MODULE_1__["addNewMessagesListener"]; });

/* harmony import */ var _add_all_new_messages__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./add-all-new-messages */ "./listeners/add-all-new-messages.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "allNewMessagesListener", function() { return _add_all_new_messages__WEBPACK_IMPORTED_MODULE_2__["allNewMessagesListener"]; });

/* harmony import */ var _add_on_state_change__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./add-on-state-change */ "./listeners/add-on-state-change.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addOnStateChange", function() { return _add_on_state_change__WEBPACK_IMPORTED_MODULE_3__["addOnStateChange"]; });

/* harmony import */ var _add_on_new_ack__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./add-on-new-ack */ "./listeners/add-on-new-ack.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addOnNewAcks", function() { return _add_on_new_ack__WEBPACK_IMPORTED_MODULE_4__["addOnNewAcks"]; });

/* harmony import */ var _add_on_live_location__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./add-on-live-location */ "./listeners/add-on-live-location.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addOnLiveLocation", function() { return _add_on_live_location__WEBPACK_IMPORTED_MODULE_5__["addOnLiveLocation"]; });

/* harmony import */ var _add_on_participants_change__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./add-on-participants-change */ "./listeners/add-on-participants-change.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addOnParticipantsChange", function() { return _add_on_participants_change__WEBPACK_IMPORTED_MODULE_6__["addOnParticipantsChange"]; });

/* harmony import */ var _add_on_added_to_group__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./add-on-added-to-group */ "./listeners/add-on-added-to-group.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "addOnAddedToGroup", function() { return _add_on_added_to_group__WEBPACK_IMPORTED_MODULE_7__["addOnAddedToGroup"]; });











/***/ }),

/***/ "./listeners/init-listeners.js":
/*!*************************************!*\
  !*** ./listeners/init-listeners.js ***!
  \*************************************/
/*! exports provided: initNewMessagesListener */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "initNewMessagesListener", function() { return initNewMessagesListener; });
/**
 * This needs to be executed before new adding new message listeners
 */
function initNewMessagesListener() {
  window.WAPI._newMessagesListener = window.Store.Msg.on(
    'add',
    (newMessage) => {
      if (newMessage && newMessage.isNewMsg && !newMessage.isSentByMe) {
        let message = window.WAPI.processMessageObj(newMessage, false, false);
        if (message) {
          window.WAPI._newMessagesQueue.push(message);
          window.WAPI._newMessagesBuffer.push(message);
        }

        // Starts debouncer time to don't call a callback for each message if more than one message arrives
        // in the same second
        if (
          !window.WAPI._newMessagesDebouncer &&
          window.WAPI._newMessagesQueue.length > 0
        ) {
          window.WAPI._newMessagesDebouncer = setTimeout(() => {
            let queuedMessages = window.WAPI._newMessagesQueue;

            window.WAPI._newMessagesDebouncer = null;
            window.WAPI._newMessagesQueue = [];

            let removeCallbacks = [];

            window.WAPI._newMessagesCallbacks.forEach(function (callbackObj) {
              if (callbackObj.callback !== undefined) {
                callbackObj.callback(queuedMessages);
              }
              if (callbackObj.rmAfterUse === true) {
                removeCallbacks.push(callbackObj);
              }
            });

            // Remove removable callbacks.
            removeCallbacks.forEach(function (rmCallbackObj) {
              let callbackIndex = window.WAPI._newMessagesCallbacks.indexOf(
                rmCallbackObj
              );
              window.WAPI._newMessagesCallbacks.splice(callbackIndex, 1);
            });
          }, 1000);
        }
      }
    }
  );

  window.WAPI._unloadInform = (event) => {
    // Save in the buffer the ungot unreaded messages
    window.WAPI._newMessagesBuffer.forEach((message) => {
      Object.keys(message).forEach((key) =>
        message[key] === undefined ? delete message[key] : ''
      );
    });
    sessionStorage.setItem(
      'saved_msgs',
      JSON.stringify(window.WAPI._newMessagesBuffer)
    );

    // Inform callbacks that the page will be reloaded.
    window.WAPI._newMessagesCallbacks.forEach(function (callbackObj) {
      if (callbackObj.callback !== undefined) {
        callbackObj.callback({
          status: -1,
          message: 'page will be reloaded, wait and register callback again.',
        });
      }
    });
  };
}


/***/ }),

/***/ "./serializers/index.js":
/*!******************************!*\
  !*** ./serializers/index.js ***!
  \******************************/
/*! exports provided: _serializeChatObj, _serializeRawObj, _serializeMessageObj, _serializeContactObj, _serializeNumberStatusObj, _serializeProfilePicThumb */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _serialize_chat__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./serialize-chat */ "./serializers/serialize-chat.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeChatObj", function() { return _serialize_chat__WEBPACK_IMPORTED_MODULE_0__["_serializeChatObj"]; });

/* harmony import */ var _serialize_raw__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./serialize-raw */ "./serializers/serialize-raw.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeRawObj", function() { return _serialize_raw__WEBPACK_IMPORTED_MODULE_1__["_serializeRawObj"]; });

/* harmony import */ var _serialize_message__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./serialize-message */ "./serializers/serialize-message.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeMessageObj", function() { return _serialize_message__WEBPACK_IMPORTED_MODULE_2__["_serializeMessageObj"]; });

/* harmony import */ var _serialize_contact__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./serialize-contact */ "./serializers/serialize-contact.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeContactObj", function() { return _serialize_contact__WEBPACK_IMPORTED_MODULE_3__["_serializeContactObj"]; });

/* harmony import */ var _serialize_number_status__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./serialize-number-status */ "./serializers/serialize-number-status.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeNumberStatusObj", function() { return _serialize_number_status__WEBPACK_IMPORTED_MODULE_4__["_serializeNumberStatusObj"]; });

/* harmony import */ var _serialize_profile_pic_thumb__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./serialize-profile-pic-thumb */ "./serializers/serialize-profile-pic-thumb.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "_serializeProfilePicThumb", function() { return _serialize_profile_pic_thumb__WEBPACK_IMPORTED_MODULE_5__["_serializeProfilePicThumb"]; });








/***/ }),

/***/ "./serializers/serialize-chat.js":
/*!***************************************!*\
  !*** ./serializers/serialize-chat.js ***!
  \***************************************/
/*! exports provided: _serializeChatObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeChatObj", function() { return _serializeChatObj; });
/* harmony import */ var _serialize_raw__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./serialize-raw */ "./serializers/serialize-raw.js");


/**
 * Serializes a chat object
 *
 * @param rawChat Chat object
 * @returns {Chat}
 */
const _serializeChatObj = (obj) => {
  if (obj == undefined) {
    return null;
  }
  return Object.assign(window.WAPI._serializeRawObj(obj), {
    kind: obj.kind,
    isGroup: obj.isGroup,
    contact: obj['contact']
      ? window.WAPI._serializeContactObj(obj['contact'])
      : null,
    groupMetadata: obj['groupMetadata']
      ? window.WAPI._serializeRawObj(obj['groupMetadata'])
      : null,
    presence: obj['presence']
      ? window.WAPI._serializeRawObj(obj['presence'])
      : null,
    msgs: null,
    isOnline: obj.__x_presence.attributes.isOnline || null,
    lastSeen:
      obj &&
      obj.previewMessage &&
      obj.previewMessage.__x_ephemeralStartTimestamp
        ? obj.previewMessage.__x_ephemeralStartTimestamp * 1000
        : null,
  });
};


/***/ }),

/***/ "./serializers/serialize-contact.js":
/*!******************************************!*\
  !*** ./serializers/serialize-contact.js ***!
  \******************************************/
/*! exports provided: _serializeContactObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeContactObj", function() { return _serializeContactObj; });
/**
 * Serializes contact object
 * @param {Contact} obj
 */
const _serializeContactObj = (obj) => {
  if (obj == undefined) {
    return null;
  }
  return Object.assign(window.WAPI._serializeRawObj(obj), {
    formattedName: obj.formattedName,
    isHighLevelVerified: obj.isHighLevelVerified,
    isMe: obj.isMe,
    isMyContact: obj.isMyContact,
    isPSA: obj.isPSA,
    isUser: obj.isUser,
    isVerified: obj.isVerified,
    isWAContact: obj.isWAContact,
    profilePicThumbObj: obj.profilePicThumb
      ? WAPI._serializeProfilePicThumb(obj.profilePicThumb)
      : {},
    statusMute: obj.statusMute,
    msgs: null,
  });
};


/***/ }),

/***/ "./serializers/serialize-message.js":
/*!******************************************!*\
  !*** ./serializers/serialize-message.js ***!
  \******************************************/
/*! exports provided: _serializeMessageObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeMessageObj", function() { return _serializeMessageObj; });
/**
 * Serializes chat object
 * @param {Chat} obj
 */
const _serializeMessageObj = (obj) => {
  if (obj == undefined) {
    return null;
  }
  const _chat = WAPI._serializeChatObj(obj['chat']);
  if (obj.quotedMsg) obj.quotedMsgObj();
  return Object.assign(window.WAPI._serializeRawObj(obj), {
    id: obj.id._serialized,
    sender: obj['senderObj']
      ? WAPI._serializeContactObj(obj['senderObj'])
      : null,
    timestamp: obj['t'],
    content: obj['body'],
    isGroupMsg: obj.isGroupMsg,
    isLink: obj.isLink,
    isMMS: obj.isMMS,
    isMedia: obj.isMedia,
    isNotification: obj.isNotification,
    isPSA: obj.isPSA,
    type: obj.type,
    chat: _chat,
    isOnline: _chat.isOnline,
    lastSeen: _chat.lastSeen,
    chatId: obj.id.remote,
    quotedMsgObj: WAPI._serializeMessageObj(obj['_quotedMsgObj']),
    mediaData: window.WAPI._serializeRawObj(obj['mediaData']),
    reply: (body) => window.WAPI.reply(_chat.id._serialized, body, obj),
  });
};


/***/ }),

/***/ "./serializers/serialize-number-status.js":
/*!************************************************!*\
  !*** ./serializers/serialize-number-status.js ***!
  \************************************************/
/*! exports provided: _serializeNumberStatusObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeNumberStatusObj", function() { return _serializeNumberStatusObj; });
/**
 * Serializes number status object
 * @param {*} obj
 */
const _serializeNumberStatusObj = (obj) => {
  if (obj == undefined) {
    return null;
  }

  return Object.assign(
    {},
    {
      id: obj.jid,
      status: obj.status,
      isBusiness: obj.biz === true,
      canReceiveMessage: obj.status === 200,
    }
  );
};


/***/ }),

/***/ "./serializers/serialize-profile-pic-thumb.js":
/*!****************************************************!*\
  !*** ./serializers/serialize-profile-pic-thumb.js ***!
  \****************************************************/
/*! exports provided: _serializeProfilePicThumb */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeProfilePicThumb", function() { return _serializeProfilePicThumb; });
/**
 * Serializes profile pic (thumbnail) object
 * @param {*} obj
 */
const _serializeProfilePicThumb = (obj) => {
  if (obj == undefined) {
    return null;
  }

  return Object.assign(
    {},
    {
      eurl: obj.eurl,
      id: obj.id,
      img: obj.img,
      imgFull: obj.imgFull,
      raw: obj.raw,
      tag: obj.tag,
    }
  );
};


/***/ }),

/***/ "./serializers/serialize-raw.js":
/*!**************************************!*\
  !*** ./serializers/serialize-raw.js ***!
  \**************************************/
/*! exports provided: _serializeRawObj */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "_serializeRawObj", function() { return _serializeRawObj; });
/**
 * Serializes object into JSON format safely
 * @param {*} obj
 */
const _serializeRawObj = (obj) => {
  if (obj && obj.toJSON) {
    return obj.toJSON();
  }
  return {};
};


/***/ }),

/***/ "./store/get-store.js":
/*!****************************!*\
  !*** ./store/get-store.js ***!
  \****************************/
/*! exports provided: getStore */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getStore", function() { return getStore; });
/* harmony import */ var _store_objects__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./store-objects */ "./store/store-objects.js");


function getStore(modules) {
  let foundCount = 0;
  let neededObjects = _store_objects__WEBPACK_IMPORTED_MODULE_0__["storeObjects"];
  for (let idx in modules) {
    if (typeof modules[idx] === 'object' && modules[idx] !== null) {
      let first = Object.values(modules[idx])[0];
      if (typeof first === 'object' && first.exports) {
        for (let idx2 in modules[idx]) {
          let module = modules(idx2);
          if (!module) {
            continue;
          }
          neededObjects.forEach((needObj) => {
            if (!needObj.conditions || needObj.foundedModule) return;
            let neededModule = needObj.conditions(module);
            if (neededModule !== null) {
              foundCount++;
              needObj.foundedModule = neededModule;
            }
          });
          if (foundCount == neededObjects.length) {
            break;
          }
        }

        let neededStore = neededObjects.find(
          (needObj) => needObj.id === 'Store'
        );
        window.Store = neededStore.foundedModule
          ? neededStore.foundedModule
          : {};
        neededObjects.splice(neededObjects.indexOf(neededStore), 1);
        neededObjects.forEach((needObj) => {
          if (needObj.foundedModule) {
            window.Store[needObj.id] = needObj.foundedModule;
          }
        });
        window.Store.sendMessage = function (e) {
          return window.Store.SendTextMsgToChat(this, ...arguments);
        };
        if (window.Store.MediaCollection)
          window.Store.MediaCollection.prototype.processFiles =
            window.Store.MediaCollection.prototype.processFiles ||
            window.Store.MediaCollection.prototype.processAttachments;
        return window.Store;
      }
    }
  }
}


/***/ }),

/***/ "./store/store-objects.js":
/*!********************************!*\
  !*** ./store/store-objects.js ***!
  \********************************/
/*! exports provided: storeObjects */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "storeObjects", function() { return storeObjects; });
const storeObjects = [
  {
    id: 'Store',
    conditions: (module) => (module.Chat && module.Msg ? module : null),
  },
  {
    id: 'MediaCollection',
    conditions: (module) =>
      module.default &&
      module.default.prototype &&
      (module.default.prototype.processFiles !== undefined ||
        module.default.prototype.processAttachments !== undefined)
        ? module.default
        : null,
  },
  {
    id: 'MediaProcess',
    conditions: (module) => (module.BLOB ? module : null),
  },
  {
    id: 'ChatUtil',
    conditions: (module) => (module.sendClear ? module : null),
  },
  {
    id: 'GroupInvite',
    conditions: (module) => (module.queryGroupInviteCode ? module : null),
  },
  { id: 'Wap', conditions: (module) => (module.createGroup ? module : null) },
  {
    id: 'ServiceWorker',
    conditions: (module) =>
      module.default && module.default.killServiceWorker ? module : null,
  },
  {
    id: 'State',
    conditions: (module) => (module.STATE && module.STREAM ? module : null),
  },
  {
    id: 'WapDelete',
    conditions: (module) =>
      module.sendConversationDelete && module.sendConversationDelete.length == 2
        ? module
        : null,
  },
  {
    id: 'Conn',
    conditions: (module) =>
      module.default && module.default.ref && module.default.refTTL
        ? module.default
        : null,
  },
  {
    id: 'WapQuery',
    conditions: (module) =>
      module.queryExist
        ? module
        : module.default && module.default.queryExist
        ? module.default
        : null,
  },
  {
    id: 'CryptoLib',
    conditions: (module) => (module.decryptE2EMedia ? module : null),
  },
  {
    id: 'OpenChat',
    conditions: (module) =>
      module.default &&
      module.default.prototype &&
      module.default.prototype.openChat
        ? module.default
        : null,
  },
  {
    id: 'UserConstructor',
    conditions: (module) =>
      module.default &&
      module.default.prototype &&
      module.default.prototype.isServer &&
      module.default.prototype.isUser
        ? module.default
        : null,
  },
  {
    id: 'SendTextMsgToChat',
    conditions: (module) =>
      module.sendTextMsgToChat ? module.sendTextMsgToChat : null,
  },
  {
    id: 'SendSeen',
    conditions: (module) => (module.sendSeen ? module.sendSeen : null),
  },
  {
    id: 'sendDelete',
    conditions: (module) => (module.sendDelete ? module.sendDelete : null),
  },
  {
    id: 'addAndSendMsgToChat',
    conditions: (module) =>
      module.addAndSendMsgToChat ? module.addAndSendMsgToChat : null,
  },
  {
    id: 'sendMsgToChat',
    conditions: (module) =>
      module.sendMsgToChat ? module.sendMsgToChat : null,
  },
  {
    id: 'Catalog',
    conditions: (module) => (module.Catalog ? module.Catalog : null),
  },
  {
    id: 'bp',
    conditions: (module) =>
      module.default &&
      module.default.toString().includes('binaryProtocol deprecated version')
        ? module.default
        : null,
  },
  {
    id: 'MsgKey',
    conditions: (module) =>
      module.default &&
      module.default.toString().includes('MsgKey error: id is already a MsgKey')
        ? module.default
        : null,
  },
  {
    id: 'Parser',
    conditions: (module) =>
      module.convertToTextWithoutSpecialEmojis ? module.default : null,
  },
  {
    id: 'Builders',
    conditions: (module) =>
      module.TemplateMessage && module.HydratedFourRowTemplate ? module : null,
  },
  {
    id: 'Me',
    conditions: (module) =>
      module.PLATFORMS && module.Conn ? module.default : null,
  },
  {
    id: 'CallUtils',
    conditions: (module) =>
      module.sendCallEnd && module.parseCall ? module : null,
  },
  {
    id: 'Identity',
    conditions: (module) =>
      module.queryIdentity && module.updateIdentity ? module : null,
  },
  {
    id: 'MyStatus',
    conditions: (module) =>
      module.getStatus && module.setMyStatus ? module : null,
  },
  {
    id: 'ChatStates',
    conditions: (module) =>
      module.sendChatStatePaused &&
      module.sendChatStateRecording &&
      module.sendChatStateComposing
        ? module
        : null,
  },
  {
    id: 'GroupActions',
    conditions: (module) =>
      module.sendExitGroup && module.localExitGroup ? module : null,
  },
  {
    id: 'Features',
    conditions: (module) =>
      module.FEATURE_CHANGE_EVENT && module.features ? module : null,
  },
  {
    id: 'MessageUtils',
    conditions: (module) =>
      module.storeMessages && module.appendMessage ? module : null,
  },
  {
    id: 'WebMessageInfo',
    conditions: (module) =>
      module.WebMessageInfo && module.WebFeatures
        ? module.WebMessageInfo
        : null,
  },
  {
    id: 'createMessageKey',
    conditions: (module) =>
      module.createMessageKey && module.createDeviceSentMessage
        ? module.createMessageKey
        : null,
  },
  {
    id: 'Participants',
    conditions: (module) =>
      module.addParticipants &&
      module.removeParticipants &&
      module.promoteParticipants &&
      module.demoteParticipants
        ? module
        : null,
  },
  {
    id: 'WidFactory',
    conditions: (module) =>
      module.numberToWid && module.createWid && module.createWidFromWidLike
        ? module
        : null,
  },
  {
    id: 'Base',
    conditions: (module) =>
      module.setSubProtocol && module.binSend && module.actionNode
        ? module
        : null,
  },
  {
    id: 'Base2',
    conditions: (module) =>
      module.supportsFeatureFlags &&
      module.parseMsgStubProto &&
      module.binSend &&
      module.subscribeLiveLocation
        ? module
        : null,
  },
  {
    id: 'Versions',
    conditions: (module) =>
      module.loadProtoVersions &&
      module.default['15'] &&
      module.default['16'] &&
      module.default['17']
        ? module
        : null,
  },
  {
    id: 'Sticker',
    conditions: (module) =>
      module.default && module.default.Sticker ? module.default.Sticker : null,
  },
  {
    id: 'MediaUpload',
    conditions: (module) =>
      module.default && module.default.mediaUpload ? module.default : null,
  },
  {
    id: 'UploadUtils',
    conditions: (module) =>
      module.default && module.default.encryptAndUpload ? module.default : null,
  },
  {
    id: 'Cmd',
    conditions: (module) =>
      module.default && module.default.openChatFromUnread ? module : null,
  },
];


/***/ }),

/***/ "./wapi.js":
/*!*****************!*\
  !*** ./wapi.js ***!
  \*****************/
/*! no exports provided */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _functions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./functions */ "./functions/index.js");
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helper */ "./helper/index.js");
/* harmony import */ var _listeners__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./listeners */ "./listeners/index.js");
/* harmony import */ var _serializers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./serializers */ "./serializers/index.js");
/* harmony import */ var _store_get_store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./store/get-store */ "./store/get-store.js");






if (!window.Store || !window.Store.Msg) {
  (function () {
    const parasite = `parasite${Date.now()}`;
    // webpackJsonp([], { [parasite]: (x, y, z) => getStore(z) }, [parasite]);
    if (typeof webpackJsonp === 'function')
      webpackJsonp([], { [parasite]: (x, y, z) => Object(_store_get_store__WEBPACK_IMPORTED_MODULE_4__["getStore"])(z) }, [parasite]);
    else
      webpackJsonp.push([
        [parasite],
        { [parasite]: (x, y, z) => Object(_store_get_store__WEBPACK_IMPORTED_MODULE_4__["getStore"])(z) },
        [[parasite]],
      ]);
  })();
}

window.WAPI = {
  lastRead: {},
};

// Serializers assignations
window.WAPI._serializeRawObj = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeRawObj"];
window.WAPI._serializeChatObj = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeChatObj"];
window.WAPI._serializeContactObj = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeContactObj"];
window.WAPI._serializeMessageObj = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeMessageObj"];
window.WAPI._serializeNumberStatusObj = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeNumberStatusObj"];
window.WAPI._serializeProfilePicThumb = _serializers__WEBPACK_IMPORTED_MODULE_3__["_serializeProfilePicThumb"];

// Group Functions
window.WAPI.createGroup = _functions__WEBPACK_IMPORTED_MODULE_0__["createGroup"];
window.WAPI.leaveGroup = _functions__WEBPACK_IMPORTED_MODULE_0__["leaveGroup"];
window.WAPI.revokeGroupInviteLink = _functions__WEBPACK_IMPORTED_MODULE_0__["revokeGroupInviteLink"];
window.WAPI.getGroupInviteLink = _functions__WEBPACK_IMPORTED_MODULE_0__["getGroupInviteLink"];
window.WAPI.getGroupAdmins = _functions__WEBPACK_IMPORTED_MODULE_0__["getGroupAdmins"];
window.WAPI.removeParticipant = _functions__WEBPACK_IMPORTED_MODULE_0__["removeParticipant"];
window.WAPI.addParticipant = _functions__WEBPACK_IMPORTED_MODULE_0__["addParticipant"];
window.WAPI.promoteParticipant = _functions__WEBPACK_IMPORTED_MODULE_0__["promoteParticipant"];
window.WAPI.demoteParticipant = _functions__WEBPACK_IMPORTED_MODULE_0__["demoteParticipant"];

// Chatting functions
window.WAPI.sendChatstate = _functions__WEBPACK_IMPORTED_MODULE_0__["sendChatstate"];
window.WAPI.sendMessageWithThumb = _functions__WEBPACK_IMPORTED_MODULE_0__["sendMessageWithThumb"];
window.WAPI.processMessageObj = _functions__WEBPACK_IMPORTED_MODULE_0__["processMessageObj"];
window.WAPI.sendMessageWithTags = _functions__WEBPACK_IMPORTED_MODULE_0__["sendMessageWithTags"];
window.WAPI.sendMessage = _functions__WEBPACK_IMPORTED_MODULE_0__["sendMessage"];
window.WAPI.sendMessage2 = _functions__WEBPACK_IMPORTED_MODULE_0__["sendMessage2"];
window.WAPI.sendSeen = _functions__WEBPACK_IMPORTED_MODULE_0__["sendSeen"];
window.WAPI.deleteConversation = _functions__WEBPACK_IMPORTED_MODULE_0__["deleteConversation"];
window.WAPI.deleteMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["deleteMessages"];
window.WAPI.clearChat = _functions__WEBPACK_IMPORTED_MODULE_0__["clearChat"];
window.WAPI.sendMessageToID = _functions__WEBPACK_IMPORTED_MODULE_0__["sendMessageToID"];
window.WAPI.sendImage = _functions__WEBPACK_IMPORTED_MODULE_0__["sendImage"];
window.WAPI.sendFile = _functions__WEBPACK_IMPORTED_MODULE_0__["sendFile"];
window.WAPI.setMyName = _functions__WEBPACK_IMPORTED_MODULE_0__["setMyName"];
window.WAPI.setMyStatus = _functions__WEBPACK_IMPORTED_MODULE_0__["setMyStatus"];
window.WAPI.sendVideoAsGif = _functions__WEBPACK_IMPORTED_MODULE_0__["sendVideoAsGif"];
window.WAPI.processFiles = _functions__WEBPACK_IMPORTED_MODULE_0__["processFiles"];
window.WAPI.sendImageWithProduct = _functions__WEBPACK_IMPORTED_MODULE_0__["sendImageWithProduct"];
window.WAPI.sendContact = _functions__WEBPACK_IMPORTED_MODULE_0__["sendContact"];
window.WAPI.forwardMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["forwardMessages"];
window.WAPI.reply = _functions__WEBPACK_IMPORTED_MODULE_0__["reply"];
window.WAPI._sendSticker = _functions__WEBPACK_IMPORTED_MODULE_0__["sendSticker"];
window.WAPI.encryptAndUploadFile = _functions__WEBPACK_IMPORTED_MODULE_0__["encryptAndUploadFile"];
window.WAPI.sendImageAsSticker = _functions__WEBPACK_IMPORTED_MODULE_0__["sendImageAsSticker"];
window.WAPI.startTyping = _functions__WEBPACK_IMPORTED_MODULE_0__["startTyping"];
window.WAPI.stopTyping = _functions__WEBPACK_IMPORTED_MODULE_0__["stopTyping"];
window.WAPI.sendLocation = _functions__WEBPACK_IMPORTED_MODULE_0__["sendLocation"];
window.WAPI.blockContact = _functions__WEBPACK_IMPORTED_MODULE_0__["blockContact"];
window.WAPI.unblockContact = _functions__WEBPACK_IMPORTED_MODULE_0__["unblockContact"];

// Retrieving functions
window.WAPI.getAllContacts = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllContacts"];
window.WAPI.getMyContacts = _functions__WEBPACK_IMPORTED_MODULE_0__["getMyContacts"];
window.WAPI.getContact = _functions__WEBPACK_IMPORTED_MODULE_0__["getContact"];
window.WAPI.getAllChats = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllChats"];
window.WAPI.haveNewMsg = _functions__WEBPACK_IMPORTED_MODULE_0__["hasUndreadMessages"];
window.WAPI.getAllChatsWithNewMsg = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllChatsWithNewMessages"];
window.WAPI.getAllChatIds = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllChatIds"];
window.WAPI.getAllNewMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllNewMessages"];
window.WAPI.getAllUnreadMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllUnreadMessages"];
window.WAPI.getAllChatsWithMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllChatsWithMessages"];
window.WAPI.getAllGroups = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllGroups"];
window.WAPI.getChat = _functions__WEBPACK_IMPORTED_MODULE_0__["getChat"];
window.WAPI.getStatus = _functions__WEBPACK_IMPORTED_MODULE_0__["getStatus"];
window.WAPI.getChatByName = _functions__WEBPACK_IMPORTED_MODULE_0__["getChatByName"];
window.WAPI.getNewId = _functions__WEBPACK_IMPORTED_MODULE_0__["getNewId"];
window.WAPI.getChatById = _functions__WEBPACK_IMPORTED_MODULE_0__["getChatById"];
window.WAPI.getUnreadMessagesInChat = _functions__WEBPACK_IMPORTED_MODULE_0__["getUnreadMessagesInChat"];
window.WAPI.loadEarlierMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["loadChatEarlierMessages"];
window.WAPI.loadAllEarlierMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["loadAllEarlierMessages"];
window.WAPI.asyncLoadAllEarlierMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["asyncLoadAllEarlierMessages"];
window.WAPI.areAllMessagesLoaded = _functions__WEBPACK_IMPORTED_MODULE_0__["areAllMessagesLoaded"];
window.WAPI.loadEarlierMessagesTillDate = _functions__WEBPACK_IMPORTED_MODULE_0__["loadEarlierMessagesTillDate"];
window.WAPI.getAllGroupMetadata = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllGroupMetadata"];
window.WAPI.getGroupMetadata = _functions__WEBPACK_IMPORTED_MODULE_0__["getGroupMetadata"];
window.WAPI._getGroupParticipants = _functions__WEBPACK_IMPORTED_MODULE_0__["_getGroupParticipants"];
window.WAPI.getGroupParticipantIDs = _functions__WEBPACK_IMPORTED_MODULE_0__["getGroupParticipantIDs"];
window.WAPI.getAllMessagesInChat = _functions__WEBPACK_IMPORTED_MODULE_0__["getAllMessagesInChat"];
window.WAPI.loadAndGetAllMessagesInChat = _functions__WEBPACK_IMPORTED_MODULE_0__["loadAndGetAllMessagesInChat"];
window.WAPI.getUnreadMessages = _functions__WEBPACK_IMPORTED_MODULE_0__["getUnreadMessages"];
window.WAPI.getCommonGroups = _functions__WEBPACK_IMPORTED_MODULE_0__["getCommonGroups"];
window.WAPI.getProfilePicFromServer = _functions__WEBPACK_IMPORTED_MODULE_0__["getProfilePicFromServer"];
window.WAPI.downloadFileWithCredentials = _functions__WEBPACK_IMPORTED_MODULE_0__["downloadFileWithCredentials"];
window.WAPI.getNumberProfile = _functions__WEBPACK_IMPORTED_MODULE_0__["getNumberProfile"];
window.WAPI.getMessageById = _functions__WEBPACK_IMPORTED_MODULE_0__["getMessageById"];
window.WAPI.getNewMessageId = _functions__WEBPACK_IMPORTED_MODULE_0__["getNewMessageId"];
window.WAPI.getFileHash = _helper__WEBPACK_IMPORTED_MODULE_1__["getFileHash"];
window.WAPI.generateMediaKey = _helper__WEBPACK_IMPORTED_MODULE_1__["generateMediaKey"];
window.WAPI.arrayBufferToBase64 = _helper__WEBPACK_IMPORTED_MODULE_1__["arrayBufferToBase64"];

// Device functions
window.WAPI.getHost = _functions__WEBPACK_IMPORTED_MODULE_0__["getHost"];
window.WAPI.getMe = _functions__WEBPACK_IMPORTED_MODULE_0__["getMe"];
window.WAPI.isLoggedIn = _functions__WEBPACK_IMPORTED_MODULE_0__["isLoggedIn"];
window.WAPI.isConnected = _functions__WEBPACK_IMPORTED_MODULE_0__["isConnected"];
window.WAPI.getBatteryLevel = _functions__WEBPACK_IMPORTED_MODULE_0__["getBatteryLevel"];
window.WAPI.base64ImageToFile = _helper__WEBPACK_IMPORTED_MODULE_1__["base64ToFile"];
window.WAPI.base64ToFile = _helper__WEBPACK_IMPORTED_MODULE_1__["base64ToFile"];

// Listeners initialization
window.WAPI._newMessagesQueue = [];
window.WAPI._newMessagesBuffer =
  sessionStorage.getItem('saved_msgs') != null
    ? JSON.parse(sessionStorage.getItem('saved_msgs'))
    : [];
window.WAPI._newMessagesDebouncer = null;
window.WAPI._newMessagesCallbacks = [];
window.Store.Msg.off('add');
sessionStorage.removeItem('saved_msgs');
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["initNewMessagesListener"])();

// Listeners
window.addEventListener('unload', window.WAPI._unloadInform, false);
window.addEventListener('beforeunload', window.WAPI._unloadInform, false);
window.addEventListener('pageunload', window.WAPI._unloadInform, false);
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addNewMessagesListener"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["allNewMessagesListener"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addOnStateChange"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addOnNewAcks"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addOnLiveLocation"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addOnParticipantsChange"])();
Object(_listeners__WEBPACK_IMPORTED_MODULE_2__["addOnAddedToGroup"])();

// On-work below:

/**
 * New version of @tag message
 */
window.WAPI.sendMessageMentioned = async function (chatId, message, mentioned) {
  if (!Array.isArray(mentioned)) {
    mentioned = [mentioned];
  }

  const chat = WAPI.getChat(chatId);
  const users = await Store.Contact.serialize().filter((x) =>
    mentioned.includes(x.id.user)
  );

  chat.sendMessage(message, {
    linkPreview: null,
    mentionedJidList: users.map((u) => u.id),
    quotedMsg: null,
    quotedMsgAdminGroupJid: null,
  });
};

window.WAPI.getProfilePicSmallFromId = function (id, done) {
  window.Store.ProfilePicThumb.find(id).then(
    function (d) {
      if (d.img !== undefined) {
        window.WAPI.downloadFileWithCredentials(d.img, done);
      } else {
        done(false);
      }
    },
    function (e) {
      done(false);
    }
  );
};

window.WAPI.getProfilePicFromId = function (id, done) {
  window.Store.ProfilePicThumb.find(id).then(
    function (d) {
      if (d.imgFull !== undefined) {
        window.WAPI.downloadFileWithCredentials(d.imgFull, done);
      } else {
        done(false);
      }
    },
    function (e) {
      done(false);
    }
  );
};

window.WAPI.getWAVersion = function () {
  return window.Debug.VERSION;
};


/***/ })

/******/ });
//# sourceMappingURL=wapi.js.map